using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using BaseLibrary;

namespace Spline6
{
    public partial class Form1 : Form
    {

        DifferenceIntegration differenceIntegration = new DifferenceIntegration();

        public Form1()
        {
            InitializeComponent();
            this.textBox1.Text = "-1.0";
            this.textBox2.Text = "1.0";
            comboBox1.SelectedItem = "1";
            comboBox2.SelectedItem = "1";
            comboBox3.SelectedItem = "1";
            comboBox4.SelectedItem = "3";
            this.textBox3.Text = differenceIntegration.Number.ToString();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            System.Globalization.NumberFormatInfo provider = new System.Globalization.NumberFormatInfo();
            provider.NumberDecimalSeparator = ",";
            provider.NumberGroupSeparator = " ";
            provider.NumberGroupSizes = new int[] { 3 };

            string str = this.textBox1.Text;
            str = str.Replace('.', ',');
            differenceIntegration.Rangemin = Convert.ToDouble(str, provider);
            str = this.textBox2.Text;
            str = str.Replace('.', ',');
            differenceIntegration.Rangemax = Convert.ToDouble(str, provider);

            differenceIntegration.Number = Convert.ToInt32(this.textBox3.Text);
            int num = differenceIntegration.Number;
            if (num < 5 || num > BasicFunctionClass.N)
            {
                MessageBox.Show("   .   1 : " + BasicFunctionClass.N.ToString());
                return;
            }
            differenceIntegration.h = (differenceIntegration.Rangemax - differenceIntegration.Rangemin) / (double)(num - 1);
            BasicFunctionClass.KeyOfJob = Convert.ToInt32(comboBox1.SelectedItem);
            BasicFunctionClass.primer = Convert.ToInt32(comboBox2.SelectedItem);
            differenceIntegration.NamberMethod = Convert.ToInt32(comboBox3.SelectedItem);
            differenceIntegration.power = Convert.ToInt32(comboBox4.SelectedItem);
            if ((BasicFunctionClass.KeyOfJob == 3) && (differenceIntegration.NamberMethod == 2))
            {
                differenceIntegration.MatrixVectf(BasicFunctionClass.a, differenceIntegration.b);
                BasicFunctionClass.Gauss(BasicFunctionClass.n, BasicFunctionClass.a, differenceIntegration.b, differenceIntegration.x);
                differenceIntegration.Tabulation(differenceIntegration.xp, differenceIntegration.yp, differenceIntegration.zp);
            }
            else
            {
                differenceIntegration.Tabulation(differenceIntegration.xp, differenceIntegration.yp, differenceIntegration.zp);
            }

            Form2 frm = new Form2();
            frm.Show();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.Close();
        }

    }
}