using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using BaseLibrary;

namespace Spline7
{
    public partial class Form1 : Form
    {

        ProblemCochy problemCochy = new ProblemCochy();

        public Form1()
        {

            InitializeComponent();
            this.textBox1.Text = "-1.0";
            this.textBox2.Text = "1.0";
            this.textBox3.Text = problemCochy.Number.ToString();
            comboBox1.SelectedItem = "1";
            comboBox2.SelectedItem = "1";
            comboBox3.SelectedItem = "1";
            comboBox4.SelectedItem = "1";
        }

        private void button1_Click(object sender, EventArgs e)
        {
            System.Globalization.NumberFormatInfo provider = new System.Globalization.NumberFormatInfo();
            provider.NumberDecimalSeparator = ",";
            provider.NumberGroupSeparator = " ";
            provider.NumberGroupSizes = new int[] { 3 };
            problemCochy.Number = Convert.ToInt32(this.textBox3.Text);
            int num = problemCochy.Number;
            if (num < 5 || num > 1001)
            {
                MessageBox.Show("   .   1 : " + 1001.ToString());
                return;
            }
            string str = this.textBox1.Text;
            str = str.Replace('.', ',');
            problemCochy.Rangemin = Convert.ToDouble(str, provider);
            str = this.textBox2.Text;
            str = str.Replace('.', ',');
            problemCochy.Rangemax = Convert.ToDouble(str, provider);
            problemCochy.h = (problemCochy.Rangemax - problemCochy.Rangemin) / (double)(num - 1);
            problemCochy.NumberMethod = Convert.ToInt32(comboBox3.SelectedItem);
            BasicFunctionClass.KeyOfJob = Convert.ToInt32(comboBox2.SelectedItem);
            problemCochy.primer1 = Convert.ToInt32(comboBox1.SelectedItem);
            problemCochy.primer2 = Convert.ToInt32(comboBox4.SelectedItem);
            problemCochy.Tabulation(problemCochy.xp, problemCochy.yp, problemCochy.zp);
            Form2 frm = new Form2();
            frm.Show();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.Close();
        }

    }
}