using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using BaseLibrary;

namespace Spline8
{
    public partial class Form1 : Form
    {

        EvolutionEquation evolutionEquation = new EvolutionEquation();

        public Form1()
        {
            InitializeComponent();
            System.Globalization.NumberFormatInfo provider = new System.Globalization.NumberFormatInfo();

            provider.NumberDecimalSeparator = ",";
            provider.NumberGroupSeparator = " ";
            provider.NumberGroupSizes = new int[] { 3 };

            this.textBox1.Text = "-1.0";
            this.textBox2.Text = "1.0";

            comboBox1.SelectedItem = "2";
            comboBox2.SelectedItem = "1";
            comboBox3.SelectedItem = "1";
            comboBox4.SelectedItem = "1";

            this.textBox3.Text = evolutionEquation.Number.ToString();

        }

        private void button1_Click(object sender, EventArgs e)
        {
            System.Globalization.NumberFormatInfo provider = new System.Globalization.NumberFormatInfo();
            provider.NumberDecimalSeparator = ",";
            provider.NumberGroupSeparator = " ";
            provider.NumberGroupSizes = new int[] { 3 };

            evolutionEquation.Number = Convert.ToInt32(this.textBox3.Text);
            int num = evolutionEquation.Number;
            if (num < 5 || num > BasicFunctionClass.N)
            {
                MessageBox.Show("   .   5 : " + BasicFunctionClass.N.ToString());
                return;
            }

            string str = this.textBox1.Text;
            str = str.Replace('.', ',');
            evolutionEquation.Rangemin = Convert.ToDouble(str, provider);
            str = this.textBox2.Text;
            str = str.Replace('.', ',');
            evolutionEquation.Rangemax = Convert.ToDouble(str, provider);

            evolutionEquation.h = (evolutionEquation.Rangemax - evolutionEquation.Rangemin) / (double)(num - 1);

            BasicFunctionClass.KeyOfJob = Convert.ToInt32(comboBox1.SelectedItem);
            evolutionEquation.primer2 = Convert.ToInt32(comboBox2.SelectedItem);
            evolutionEquation.NumberMethod2 = Convert.ToInt32(comboBox3.SelectedItem);
            evolutionEquation.NumberSlay = Convert.ToInt32(comboBox4.SelectedItem);

            if (BasicFunctionClass.KeyOfJob == 1)
            {
                evolutionEquation.primer2 = Convert.ToInt32(comboBox2.SelectedItem);
                if (evolutionEquation.primer2 > 9)
                {
                    MessageBox.Show("  .    10.");
                    return;
                }
                evolutionEquation.NumberMethod2 = Convert.ToInt32(comboBox3.SelectedItem);
                if (evolutionEquation.NumberMethod2 > 8)
                {
                    MessageBox.Show("  .    9.");
                    return;
                }

                if (evolutionEquation.NumberMethod2 < 5)
                {
                    evolutionEquation.MatrixVect2(BasicFunctionClass.a, evolutionEquation.b);
                    int n2 = BasicFunctionClass.n * BasicFunctionClass.n;
                    BasicFunctionClass.Gauss(n2, BasicFunctionClass.a, evolutionEquation.b, evolutionEquation.x);
                    evolutionEquation.Tabulation(evolutionEquation.xp, evolutionEquation.yp, evolutionEquation.zp);
                }
                else
                {
                    if (evolutionEquation.NumberMethod2 > 4)
                    {
                        int n2 = BasicFunctionClass.n * BasicFunctionClass.n;
                        evolutionEquation.MatrixVect2Z(n2, BasicFunctionClass.a, evolutionEquation.b);
                        BasicFunctionClass.Relax(n2, BasicFunctionClass.a, evolutionEquation.b, evolutionEquation.x);
                        evolutionEquation.Tabulation(evolutionEquation.xp, evolutionEquation.yp, evolutionEquation.zp);
                    }
                }
            }
            else
                if (BasicFunctionClass.KeyOfJob == 2)
                {
                    evolutionEquation.Tabulation(evolutionEquation.xp, evolutionEquation.yp, evolutionEquation.zp);
                }
            Form2 frm = new Form2();
            frm.Show();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.Close();
        }

    }
}