﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using BaseLibrary;

namespace Spline8
{
    class ProblemCochyBoundary : BasicFunctionClass
    {
        public const double pi = 3.14159265358979323846264338327950288419716939937510;

        //public const int n = 57;
        public const int ng = 1024; 
        //public const double a1 = 0.0;
        //public const double b1 = 15.0;           //область определения функций 
        public double z = (double)(n - 1);
        //public double h = (b1 - a1) / (double)(n - 1);
        //public const int pr = 5;                //порядок функций Бесселя или Чебышева
        //public int primer = 1; 
        public int primer1 = 1; 
        public int primer2 = 3;
        //public int method_approx = 1; //1-первый порядок уравнения, 2-второй порядок уравнения
        //public int kluch = 3; //1-метод Рунге-Кутта, 2-О-сплайн, 3-двумерный сплайн (для ур-я 1-го порядка)
        public int NumberMethod = 3; //1-метод Рунге-Кутта, 2-О-сплайн, 3-двумерный сплайн (для ур-я 1-го порядка)
        //public int KeyOfJob = 1;

        public double[] b = new double[n];
        public double[] x = new double[n];
        public double[] c = new double[n];
        public int[] xp = new int[ng];
        public int[] yp = new int[ng];
        public int[] zp = new int[ng];
        public double[] alf = new double[n];
        public double[] bet = new double[n];
        public double[] gam = new double[n];
        public double[] bs = new double[n];
        public double[] cs = new double[n];
        public double[] ds = new double[n];
        public double[] es = new double[n];
        public double[] m = new double[n];

        //static public int number = n;
        //public int Number
        //{
        //    get { return number; }
        //    set { number = value; }
        //}

        //static public double rangemin = a1;
        //public double Rangemin
        //{
        //    get { return rangemin; }
        //    set { rangemin = value; }
        //}

        //static public double rangemax = b1;
        //public double Rangemax
        //{
        //    get { return rangemax; }
        //    set { rangemax = value; }
        //}

        static public int numberGr = 1024;
        public int NumberGr
        {
            get { return numberGr; }
            set { numberGr = value; }
        }

        static public int[] xcoord;
        public int[] Xcoord
        {
            get { return xcoord; }
            set { xcoord = value; }
        }

        static public int[] ycoord;
        public int[] Ycoord
        {
            get { return ycoord; }
            set { ycoord = value; }
        }

        static public int[] zcoord;
        public int[] Zcoord
        {
            get { return zcoord; }
            set { zcoord = value; }
        }

        //public double sgn(double x)
        //{
        //    if (x < 0.0) return -1.0;
        //    else if (x > 0.0) return 1.0;
        //    else return 0.0;
        //}

        //public double step(int n, double x)
        //{
        //    if (n < 0) return 0.0;
        //    else
        //        switch (n)
        //        {
        //            case 0: return 1.0;
        //            case 1: return x;
        //            default: return x * step(n - 1, x);
        //        }
        //}

        //public double fB(int pr, double x, double y)
        //{
        //    return Math.Cos(x * Math.Sin(y) - pr * y) / pi;
        //}

        //public double Bessel(int pr, double x)
        //{
        //    int i, n1; double y, s1, s2, h;

        //    n1 = 15; h = pi / (2.0 * n1); s2 = 0.0; s1 = fB(pr, x, pi - h); y = 0.0;
        //    for (i = 1; i < n1; i++)
        //    {
        //        y = y + h; s1 = s1 + fB(pr, x, y);
        //        y = y + h; s2 = s2 + fB(pr, x, y);
        //    };
        //    return (fB(pr, x, 0.0) + fB(pr, x, pi) + 4.0 * s1 + 2.0 * s2) * h / 3.0;
        //}



        //public double Erf(double x)
        //{
        //    double y, a1, a2, a3, a4, a5, p, t, z, r;
        //    p = 0.3275911; a1 = 0.254829592; a2 = -0.284496736; a3 = 1.421413741; a4 = -1.453152027;
        //    a5 = 1.061405429;
        //    y = Math.Abs(x); t = 1.0 / (1 + p * y);
        //    if (y > 10.0) z = 0.0;
        //    else z = Math.Exp(-y * y);
        //    r = 1.0 - (a1 * t + a2 * t * t + a3 * step(3, t) + a4 * step(4, t) + a5 * step(5, t)) * z;
        //    if (x < 0.0) r = -r;
        //    return r;
        //}

 

 //22222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222
        public double p2(double x)
        {
            double a = 1.0;
            switch (primer2)
            {
                case 1: return 1.0;// задача 15)
                case 2: return 1.0;//задача 5),x>=0
                case 3: return (1.0 + x * x);//задача 18)

                case 4: return x * x;//задача 17)
                case 5: return 1.0;//задача 16)
                case 6: return x;//задача 19),x>0.0
                case 7: return x;//задача 14),x>0.0
                case 8: return (1.0 + x * x);//задача 11)
                case 9: return x * Math.Cos(x) - Math.Sin(x);//задача 10),x>0,x<=pi
                case 10: return 1.0;//задача 13)
                case 11: return 1.0;//задача 8)
                case 12: return x;//задача 9),x>0
                case 13: return 1.0;//задача 20)
                case 14: return 1.0;//задача 6),x>=0
                case 15: return 1.0;//задача 12)
                case 16: return 0.02 * step(3, 1.0 + 25.0 * x * x);
                case 17: return x * x;     //Функция Бесселя
                case 18: return (1.0 - x * x) * x;     //Полный эллиптический интеграл
                case 19: return (x * x - 0.25) * x * x;
                case 20: return step(2, a * a + x * x); //задача 7)
                case 21: return (1.0 + x * x);
                case 22: return (x * x - 1.0);
                case 23: return (x * x - 1.0);
                case 24: return (x * x - 1.0);
                case 25: return Math.Sin(x);

                default:
                    MessageBox.Show("sorry, primer2");
                    return 0.0;
            }
        }

        public double q2(double x)
        {
            double ad = 1.0; int bi = 0;//параметры для задачи 12
            double a6 = -1.0;//параметры для задачи 14
            switch (primer2)
            {
                case 1: return 4.0 * x;
                case 2: return x;
                case 3: return 2.0 * x;

                case 4: return -2.0 * x;
                case 5: return x;
                case 6: return -(x + 1.0);
                case 7: return -(x + 1.0);
                case 8: return 4.0 * x;
                case 9: return x * Math.Sin(x);
                case 10: return Math.Sin(x) / Math.Cos(x);
                case 11: return Math.Sin(x) / Math.Cos(x);
                case 12: return -2.0 * (ad * x + bi);
                case 13: return -4.0 * x;
                case 14: return 2.0 * a6 * x;
                case 15: return -4.0 * x;
                case 16: return 0.02 * step(2, 1.0 + 25.0 * x * x);
                case 17: return x;     //Функция Бесселя
                case 18: return (1.0 - x * x);
                case 19: return 0.0;
                case 20: return 0.0;
                case 21: return x;
                case 22: return -x;
                case 23: return 1.0;
                case 24: return x;
                case 25: return (Math.Sin(x) * Math.Sin(x) - Math.Cos(x));
                default:
                    MessageBox.Show("sorry, primer2");
                    return 0.0;
            }

        }

        public double r2(double x)
        {
            double ad = 1.0; int bi = 0; double a6 = -1.0; double k4 = 0.25; //параметр для задачи 4)
            double b = 1.0; //параметры для задачи 16
            switch (primer2)
            {
                case 1: return (2.0 + x * x * 4.0);
                case 2: return (0.5 + x * x / 4.0);
                case 3: return 1.0 / (1.0 + x * x);

                case 4: return (2.0 + k4 * k4 * x * x);
                case 5: return 0.25 * x * x - 1.0;
                case 6: return -2.0 * (x - 1.0);
                case 7: return 1.0;
                case 8: return 2.0;
                case 9: return -Math.Sin(x);
                case 10: return -Math.Cos(x) * Math.Cos(x);
                case 11: return Math.Cos(x) * Math.Cos(x);
                case 12: return ad * ad * x + 2.0 * ad * bi;
                case 13: return (4.0 * x * x - 2.0);
                case 14: return step(2, a6 * x);
                case 15: return (1.0 + 4.0 * x * x);
                case 16: return 1.0 + 25.0 * x * x;
                case 17: return x * x - pr * pr;     //Функция Бесселя
                case 18: return x;
                case 19: return 1.0 / 16.0;
                case 20: return b * b;
                case 21: return 2.0;
                case 22: return -3.0;
                case 23: return -6.0;
                case 24: return -0.25;
                case 25: return Math.Sin(x) * Math.Sin(x) * Math.Sin(x);

                default:
                    MessageBox.Show("sorry, primer2");
                    return 0.0;
            }

        }

        public double fg2(double x)
        {
            switch (primer2)
            {
                case 1: return 0.0;
                case 2: return 0.0;
                case 3: return 0.0;

                case 4: return 0.0;
                case 5: return 0.0;
                case 6: return 0.0;
                case 7: return 0.0;
                case 8: return 2.0 * (Math.Cos(x) - x);
                case 9: return 0.0;
                case 10: return 0.0;
                case 11: return 0.0;
                case 12: return 0.0;
                case 13: return 0.0;
                case 14: return 0.0;
                case 15: return Math.Exp(x * x);
                case 16: return 75.0 * x * x - x;
                case 17: return 0.0;     //Функция Бесселя
                case 18: return 0.0;     //задача 18)
                case 19: return 0.0;
                case 20: return 0.0;
                case 21: return 0.0;
                case 22: return 0.0;
                case 23: return 0.0;
                case 24: return 0.0;
                case 25: return 0.0;
                default:
                    MessageBox.Show("sorry, primer2");
                    return 0.0;
            }

        }

        public double re2(double x)
        {
            double c1 = 1.0; double c2 = 1.0;
            double ad = 1.0; int bi = 0; double a6 = -1.0; double k4 = 0.25;
            double a = 1.0; double b = 1.0;
            double u;
            switch (primer2)
            {
                case 1: return Math.Exp(-x * x) * (c1 + c2 * x);
                case 2: return Math.Exp(-x * x / 4) * (c2 + c1 * x);
                case 3: return 1.0 / Math.Sqrt(1.0 + x * x) * (c1 + c2 * x);

                case 4: return x * (c1 * Math.Cos(k4 * x) + c2 * Math.Sin(k4 * x));
                case 5: return Math.Exp(-x * x / 4.0) * (c1 * Math.Exp(x * Math.Sqrt(1.5)) + 
                    c2 * Math.Exp(-x * Math.Sqrt(1.5)));
                case 6: return c1 * (3.0 * x + 1.0) * Math.Exp(-x) + c2 * Math.Exp(2.0 * x);
                case 7: return c1 * (x + 1) + c2 * Math.Exp(x);
                case 8: return 1.0 / (1.0 + x * x) * (c1 + c2 * x - x * x * x / 3.0 - 2.0 * Math.Cos(x));
                case 9: return c1 * x + c2 * Math.Sin(x);
                case 10: return c1 * Math.Exp(Math.Sin(x)) + c2 * Math.Exp(-Math.Sin(x));
                case 11: return c1 * Math.Cos(Math.Sin(x)) + c2 * Math.Sin(Math.Sin(x));
                case 12: return Math.Exp(ad * x) * (c1 + c2 * step(2 * bi + 1, x));
                case 13: return Math.Exp(x * x) * (c1 + c2 * x);
                case 14: return (a6 > 0.0) ? Math.Exp(-a6 * x * x / 2.0) * (c1 * Math.Cosh(x * Math.Sqrt(a6)) +
                    c2 * Math.Sinh(x * Math.Sqrt(a6))) :
                             Math.Exp(-a6 * x * x / 2.0) * (c1 * Math.Cos(x * Math.Sqrt(-a6)) + 
                             c2 * Math.Sin(x * Math.Sqrt(-a6)));
                case 15: return Math.Exp(x * x) * (1.0 + c1 * Math.Cos(x) + c2 * Math.Sin(x));
                case 16: return 1.0 / (1.0 + 25.0 * x * x);
                case 17: return Bessel(pr, x);     //Функция Бесселя
                case 19: return c1 * Math.Sqrt(Math.Abs(x)) * Math.Sqrt(Math.Abs(x - 0.5)) +
                    c2 * Math.Sqrt(Math.Abs(x)) * Math.Sqrt(Math.Abs(x + 0.5));
                case 20: u = Math.Sqrt(a * a + b * b) / a * Math.Atan(x / a);
                    return Math.Sqrt(a * a + x * x) * (c1 * Math.Cos(u) + c2 * Math.Sin(u));
                case 21: u = Math.Sqrt(2.0) * Math.Log(x + Math.Sqrt(1.0 + x * x));
                    return c1 * Math.Cos(u) + c2 * Math.Sin(u);
                case 22: return c2 * step(3, Math.Sqrt(Math.Abs(x * x - 1.0)));// +c1 * (2.0 * x * x * x - x);
                case 23: return step(3, Math.Sqrt(Math.Abs(x + 1.0))) * Math.Sqrt(Math.Abs(x - 1.0)) * (4.0 * x - 1.0);
                case 24: return c1 * Math.Sqrt(Math.Abs(x + 1.0)) + c2 * Math.Sqrt(Math.Abs(x - 1.0));
                case 25: return Math.Exp(Math.Cos(x) / 2.0) * (c1 * Math.Cos(Math.Cos(x) / 2.0 * Math.Sqrt(3.0)) +
                        c2 * Math.Sin(Math.Cos(x) / 2.0 * Math.Sqrt(3.0)));
                default:
                    MessageBox.Show("sorry, primer2");
                    return 0.0;
            }
        }

        public double rep2(double x)
        {

            //double u,v;
            double c1 = 1.0; double c2 = 1.0; double ad = 1.0; int bi = 0; double a6 = -1.0; double k4 = 0.25;
            double a = 1.0; //double b = 1.0;
            switch (primer2)
            {
                case 1: return Math.Exp(-x * x) * (-x * 2.0) * (c1+ c2*x) + c2 * Math.Exp(-x * x);
                case 2: return Math.Exp(-x * x / 4) * (-x / 2.0) * (c2 + c1*x) + c1*Math.Exp(-x * x / 4.0);
                case 3: return (-x) * 1.0 / step(3, Math.Sqrt(1.0 + x * x)) * (1.0 + x) + 1.0 / Math.Sqrt(1.0 + x * x);

                case 4: return x * (-k4 * Math.Sin(k4 * x) + k4 * Math.Cos(k4 * x));
                case 5: return Math.Exp(-x * x / 4) * (-x / 2.0) * (Math.Exp(x * Math.Sqrt(1.5)) + 
                    Math.Exp(-x * Math.Sqrt(1.5))) +
                    Math.Exp(-x * x / 4) * (Math.Sqrt(1.5) * Math.Exp(x * Math.Sqrt(1.5)) - 
                    Math.Sqrt(1.5) * Math.Exp(-x * Math.Sqrt(1.5)));
                case 6: return c1 * (3.0 * Math.Exp(-x) - (3.0 * x + 1.0) * Math.Exp(-x)) + 
                    c2 * 2.0 * Math.Exp(2.0 * x);
                case 7: return c1 + c2 * Math.Exp(x);
                case 8: return -(2.0 * x) / step(2, Math.Sqrt(1.0 + x * x)) * (c1 + c2 * x - x * x * x / 3.0 - 
                    2.0 * Math.Cos(x)) + 1.0 / (1.0 + x * x) * (c2 - x * x + 2.0 * Math.Sin(x));
                case 9: return c1 + c2 * Math.Cos(x);
                case 10: return c1 * Math.Exp(Math.Sin(x)) * Math.Cos(x) - c2 * Math.Exp(-Math.Sin(x)) * Math.Cos(x);
                case 11: return -c1 * Math.Sin(Math.Sin(x)) * Math.Cos(x) + c2 * Math.Cos(Math.Sin(x)) * Math.Cos(x);
                case 12: return ad * Math.Exp(ad * x) * (c1 + c2 * step(2 * bi + 1, x)) + 
                    Math.Exp(ad * x) * (2 * bi + 1) * c2 * step(2 * bi, x);
                case 13: return Math.Exp(x * x) * (2.0 * x) * (c1 + c2 * x) + Math.Exp(x * x) * c2;
                case 14: return (a6 > 0.0) ? Math.Exp(-a6 * x * x / 2.0) * (-a6 * x) * (c1 * Math.Cosh(x * Math.Sqrt(a6))+
                    c2 * Math.Sinh(x * Math.Sqrt(a6))) +
                             Math.Exp(-a6 * x * x / 2.0) * (c1 * Math.Sinh(x * Math.Sqrt(a6)) * Math.Sqrt(a6) + 
                             c2 * Math.Cosh(x * Math.Sqrt(a6)) * Math.Sqrt(a6)) :
                             Math.Exp(-a6 * x * x / 2.0) * (-a6 * x) * (c1 * Math.Cos(x * Math.Sqrt(-a6)) + 
                             c2 * Math.Sin(x * Math.Sqrt(-a6))) +
                             Math.Exp(-a6 * x * x / 2.0) * (-c1 * Math.Sin(x * Math.Sqrt(-a6)) * Math.Sqrt(-a6) + 
                             c2 * Math.Cos(x * Math.Sqrt(-a6)) * Math.Sqrt(-a6));
                case 15: return Math.Exp(x * x) * (2.0 * x) * (1.0 + c1 * Math.Cos(x) + 
                    c2 * Math.Sin(x)) + Math.Exp(x * x) * (-c1 * Math.Sin(x) + c2 * Math.Cos(x));
                case 16: return -50.0 * x / step(2, 1.0 + 25.0 * x * x);
                case 17: return Bessel(pr, x);     //Функция Бесселя
                case 19: return c1 * Math.Sqrt(Math.Abs(x)) * Math.Sqrt(Math.Abs(x - 0.5)) +
                    c2 * Math.Sqrt(Math.Abs(x)) * Math.Sqrt(Math.Abs(x - 0.5));
                case 20: return Math.Sqrt(a * a + x * x) / a * Math.Atan(x / a);
                //              v = 1.0 / Math.Sqrt(p1 * p1 + x * x) * ((x / p1) * Math.Atan(x / p1) + 1.0);
                //              return x / Math.Sqrt(p1 * p1 + x * x) * (c1 * Math.Cos(u) + c2 * Math.Sin(u)) + 
                //                  Math.Sqrt(p1 * p1 + x * x) * (-c1 * Math.Sin(u) + c2 * Math.Cos(u) * v);
                case 21: return Math.Sqrt(2.0) * Math.Log(x + Math.Sqrt(1.0 + x * x));
                //   return c1 * Math.Cos(u) + c2 * Math.Sin(u);
                case 22: return c1 * (2.0 * x * x * x - x) + c2 * step(3, Math.Sqrt(Math.Abs(x * x - 1.0)));
                case 23: return step(3, Math.Sqrt(Math.Abs(x + 1.0))) * Math.Sqrt(Math.Abs(x - 1.0)) * (4.0 * x - 1.0);
                case 24: return c1 * Math.Sqrt(Math.Abs(x + 1.0)) + c2 * Math.Sqrt(Math.Abs(x - 1.0));
                case 25: return Math.Exp(Math.Cos(x) / 2.0) * (c1 * Math.Cos(Math.Cos(x) / 2.0 * Math.Sqrt(3.0)) +
                        c2 * Math.Sin(Math.Cos(x) / 2.0 * Math.Sqrt(3.0)));
                default:
                    MessageBox.Show("sorry, primer");
                    return 0.0;
            }
        }

 /*
        public double Fi2(double x)
        {
            double u,v,ret;
            u = x + 1.0; v = 1.0 - x;
            if (x < -1.0) ret = 0.0;
            else if (x < 0.0) ret = u * u * u / 6.0;
            else if (x < 1.0) ret = x + v * v * v / 6.0;
            else ret = x;
            return ret;
        }

        public double Fi2p(double x)
        {
            double u, v, ret;
            u = x + 1.0; v = 1.0 - x;
            if (x < -1.0) ret = 0.0;
            else if (x < 0.0) ret = u * u  / 2.0;
            else if (x < 1.0) ret = 1 -  v * v / 2.0;
            else ret = 1;
            return ret;
        }

        public double Fi2pp(double x)
        {
            double u, v, ret;
            u = x + 1.0; v = 1.0 - x;
            if (x < -1.0) ret = 0.0;
            else if (x < 0.0) ret = u;
            else if (x < 1.0) ret = v;
            else ret = 0;
            return ret;
        }
*/
 
        public double Fi2(double x)
        {
            double ret;
            if (x < -1.0) ret = 0.0;
            else if (x < 0.0) ret = x + 0.5 - x * x * x *(0.5 * x + 1.0);
            else if (x < 1.0) ret = x + 0.5 + x * x * x *(0.5 * x - 1.0);
            else ret = 1;
            return ret;
        }

        public double Fi2p(double x)
        {
            double ret;
            if (x < -1.0) ret = 0.0;
            else if (x < 0.0) ret = 1.0 - x * x * (2.0 * x + 3.0);
            else if (x < 1.0) ret = 1.0 + x * x * (2.0 * x - 3.0);
            else ret = 0.0;
            return ret;
        }

        public double Fi2pp(double x)
        {
            double ret;
            if (x < -1.0) ret = 0.0;
            else if (x < 0.0) ret = -6.0 * x * (x + 1.0);
            else if (x < 1.0) ret = 6.0 * x * (x - 1.0);
            else ret = 0;
            return ret;
        }
        
        
        public double Fii2(int i, double x)
        {
            double xi,zi;
            xi = a1 + i * h;
            zi = Fi2((x - xi) / h);
            return zi * h * h;
        }

        public double AFik2(int i, int k)
        {
            double xi, yk, zik;
            xi = a1 + i * h; yk = a1 + k * h;
            zik = p2(yk) * Fi2pp((yk - xi) / h) + q2(yk) * Fi2p((yk - xi) / h) * h + 
                r2(yk) * Fi2((yk - xi) / h) * h * h;
            return zik;
        }


        public void LambdaP2(double[] x)
        {
                int i,k; double xk,yk,s;
                x[0] = 0.0;
            for (k = 1; k < n; k++)
            {
                xk = a1 + k * h;
                yk = fg2(xk) - rep2(a1) * q2(xk) - (re2(a1) + rep2(a1) * (xk-a1)) * r2(xk);
                s = 0.0;
                for (i = 1; i < k; i++)
                    s = s + x[i] * AFik2(i,k);
                x[k] = (yk - s)/AFik2(k,k);
            }
            return; 
        }


        public double SummaP2(double[] x, double y)//стр.137
        {
            int i; double s;
            s = 0.0;
            for (i = 1; i < n; i++)
            {
                s = s + Fii2(i, y) * x[i];
            };
            return s + re2(a1) + (y-a1) * rep2(a1);
        }


                                
        //RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR


            public double FiR2(int i, double x)
            {
                double r1, ri_1, ri, t, dx, d;
                if (i == 1)
                {
                    r1 = h;dx = (x/r1)*(x/r1);
                    if (x < r1) t = 0.5*dx;
                    else t = 0.5*(Math.Log(dx) + 1.0);
                    return r1 * r1 * t;
                }
                else 
                {
                    ri_1 = (i-1)*h; ri = i*h; dx = (x/ri_1)*(x/ri_1); d = (ri/ri_1)*(ri/ri_1);
                    if (x < ri_1) t = 0.0;
                    else if (x < ri) t = 0.5 * (dx - Math.Log(dx) - 1.0);
                    else
                        t = 0.5 * (Math.Log(dx) * (d - 1.0) + d * (1.0 - Math.Log(d)) - 1.0);
                    return ri * ri * t;
                }            
                    
            }


        public double FiR2p(int i, double x)
        {
            double r1, ri_1, ri, t, dx, d;
            if (i == 1)
            {
                r1 = h; dx = (x / r1) / r1;
                if (x < r1) t = dx;
                else t = 1.0/x;
                return r1 * r1 * t;
            }
            else
            {
                ri_1 = (i - 1) * h; ri = i * h; dx = (x / ri_1) / ri_1; d = (ri / ri_1) * (ri / ri_1);
                if (x < ri_1) t = 0.0;
                else if (x < ri) t = (dx - 1.0/x);
                else
                    t = (d - 1.0)/x ;
                return ri * ri * t;
            }

        }

        public double FiR2pp(int i, double x)
        {
            double r1, ri_1, ri, t, dx, d;
            if (i == 1)
            {
                r1 = h; dx = (1.0 / r1) / r1;
                if (x < r1) t = dx;
                else if (x > r1) t = -1.0 / x/x;
                else t = 0.0;
                return r1 * r1 * t;
            }
            else
            {
                ri_1 = (i - 1) * h; ri = i * h; dx = (1.0 / ri_1) / ri_1; d = (ri / ri_1) * (ri / ri_1);
                if (x < ri_1) t = 0.0;
                else if (x < ri) t = (dx + 1.0 / x / x);
                else if (x > ri)
                    t = -(d - 1.0) / x/x;
                else t = 1.0/ri/ri;
                return ri * ri * t;
            }

        }

        public double FkR2(int k)
        {
            double x; //double u; 
            x = a1 + k * h; //if (k == 1) u = 0; else u = 1.0; 
            return p2(x) * FiR2pp(k,x) + q2(x) * FiR2p(k,x) + r2(x)*FiR2(k,x);
        }

        public double FikR2(int i, int k)
        {
            double x;
            x = a1 + k * h; 
            return p2(x) * FiR2pp(i,x) + q2(x) * FiR2p(i,x) + r2(x) * FiR2(i,x);
         }

        public void LambdaR2(double[] x)
        {
            int i, k; double y, f, s;
            x[0] = 0.0;
            for (k = 1; k < n; k++)
            {
                y = a1 + k * h;
                f = fg2(y) - rep2(a1) * q2(y) - (re2(a1) + rep2(a1) * (y - a1)) * r2(y);
                s = 0.0;
                for (i = 1; i < k; i++) // k-1 on k
                    s = s + FikR2(i, k) * x[i];
                x[k] = (f - s) / FikR2(k, k); //FkR2(k);
            }
            return;
        }


        public double SummaR2(double[] x, double y)//стр.137
        {
            int i; double s;
            s = 0.0; 
            for (i = 1; i < n; i++)
            {
                s = s + FiR2(i,y) * x[i];
            };
            return s + re2(a1) + (y - a1) * rep2(a1);
        }

        //KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK

        public double f2(double x, double u, double v)
        {
            switch (primer2)
            {
                case 1: return 0.0 - 4.0 * x * v - (2.0 + x * x * 4.0) * u;
                case 2: return 0.0 - x * v - (0.5 + x * x / 4.0) * u;
                case 3: return 0.0 - (2.0 * x) / (1.0 + x * x) * v - 1.0 / (1.0 + x * x) / (1.0 + x * x) * u;
                default:
                    MessageBox.Show("sorry, primer");
                    return 0.0;
            }
        }

        public double g2(double x, double u, double v)
        {

            return v;
        }

        public void RungeKutta2(double[] x)
        {
            int k; double k1, k2, k3, k4, q1, q2, q3, q4;
            double y = a1; double u = re2(a1); double v = rep2(a1);
            for (k = 0; k < n; k++)
            {
                x[k] = u;
                k1 = g2(y, u, v);
                q1 = f2(y, u, v);
                k2 = g2(y + h / 2.0, u + h * k1 / 2.0, v + h * q1 / 2.0);
                q2 = f2(y + h / 2.0, u + h * k1 / 2.0, v + h * q1 / 2.0);
                k3 = g2(y + h / 2.0, u + h * k2 / 2.0, v + h * q2 / 2.0);
                q3 = f2(y + h / 2.0, u + h * k2 / 2.0, v + h * q2 / 2.0);
                k4 = g2(y + h, u + h * k3, v + h * q3);
                q4 = f2(y + h, u + h * k3, v + h * q3);
                u = u + h * (k1 + 2.0 * k2 + 2.0 * k3 + k4) / 6.0;
                v = v + h * (q1 + 2.0 * q2 + 2.0 * q3 + q4) / 6.0;
                y = y + h;
            }
        }

//11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
//ddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd
        public double FDU(double x)
        {
            return step(3, Math.Sqrt(Math.Abs(x-1.0)));
                //x * x/2.0;  
                //Math.Sin(x);
                
                
        }

        public double FDUp(double x)
        {
            return 3.0 / 2.0 * Math.Sqrt(Math.Abs(x-1.0)) * sgn(x); 
                //x; 
                //Math.Cos(x); 
                
                
        }

        public double p1(double x)
        {
            switch (primer1)
            {
                case 1: return 1.0;
                case 2: return 1.0;
                case 3: return 1.0;
                case 4: return 1.0;
                case 5: return 1.0;
                case 6: return 1.0;


                default:
                    MessageBox.Show("sorry, primer1");
                    return 0.0;
            }
        }

        public double q1(double x)
        {
            double ad = 1.0; 
            switch (primer1)
            {
                case 1: return 2.0 * x;
                case 2: return Math.Cos(x);
                case 3: return Math.Cos(x);
                case 4: return Math.Tan(x);
                case 5: return ad; 
                case 6: return FDUp(x);
                default:
                    MessageBox.Show("sorry, primer1");
                    return 0.0;
            }

        }
        public double fg1(double x)
        {
            double bd = 1.0; 
            switch (primer1)
            {
                case 1: return x * Math.Exp(-x*x);
                case 2: return 0.5*Math.Sin(2.0*x);
                case 3: return Math.Exp(-Math.Sin(x));
                case 4: return Math.Sin(2.0 * x);
                case 5: return Math.Exp(+bd*x);
                case 6: return FDUp(x) * FDU(x); 
                default:
                    MessageBox.Show("sorry, primer1");
                    return 0.0;
            }

        }
        public double re1(double x)
        {
            double c = 1.0; 
            double ad = 1.0; double bd = 1.0; 
            switch (primer1)
            {
                case 1: return (x*x/2.0+c) * Math.Exp(-x * x);
                case 2: return Math.Sin(x) - 1.0 + c * Math.Exp(-Math.Sin(x)) ;
                case 3: return (x + c) * Math.Exp(-Math.Sin(x));
                case 4: return -2.0*Math.Cos(x) * Math.Cos(x) + c * Math.Cos(x);
                case 5: return x * Math.Exp(bd*x) + c * Math.Exp(-ad*x);
                case 6: return FDU(x) - 1.0 + c * Math.Exp(-FDU(x));  
                default:
                    MessageBox.Show("sorry, primer1");
                    return 0.0;
            }
        }


//pppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppp
        public double Fi1(double x)
        {
            double u, v, ret;
            u = x + 1.0; v = 1.0 - x;
            if (x < -1.0) ret = 0.0;
            else if (x < 0.0) ret = u * u / 2.0;
            else if (x < 1.0) ret = 1 - v * v / 2.0;
            else ret = 1;
            return ret;
        }

        public double Fi1p(double x)
        {
            double u, v, ret;
            u = x + 1.0; v = 1.0 - x;
            if (x < -1.0) ret = 0.0;
            else if (x < 0.0) ret = u;
            else if (x < 1.0) ret = v;
            else ret = 0;
            return ret;
        }

 
        public double Fii1(int i, double x)
        {
            double xi, zi;
            xi = a1 + i * h;
            zi = Fi1((x - xi) / h);
            return zi * h;
        }

        public double AFik1(int i, int k)
        {
            double xi, yk, zik;
            xi = a1 + i * h; yk = a1 + k * h;
            zik = p1(yk) * Fi1p((yk - xi) / h) + q1(yk) * Fi1((yk - xi) / h) * h;
            return zik;
        }


        public void LambdaP1(double[] x)
        {
            int i, k; double xk, yk, s;
            //x[0] = 0.0;
            for (k = 1; k < n; k++)
            {
                xk = a1 + k * h;
                yk = fg1(xk) - re1(a1) * q1(xk);
                s = 0.0;
                for (i = 1; i < k; i++)
                    s = s + x[i] * AFik1(i, k);
                x[k] = (yk - s) / AFik1(k, k);
            }
            return;
        }


        public double SummaP1(double[] x, double y)//стр.137
        {
            int i; double s;
            s = 0.0;
            for (i = 1; i < n; i++)
            {
                s = s + Fii1(i, y) * x[i];
            };
            return s + re1(a1);
        }
//------------------------------------------------------------------------------------------------------------------

        public double FiR1(int i, double x)
        {
            double r1, ri_1, ri, t, dx, d;
            if (i == 1)
            {
                r1 = h; dx = (x / r1) * (x / r1);
                if (x < r1) t = 0.5 * dx;
                else t = 0.5 * (Math.Log(dx) + 1.0);
                return r1 * t;
            }
            else
            {
                ri_1 = (i - 1) * h; ri = i * h; dx = (x / ri_1) * (x / ri_1); d = (ri / ri_1) * (ri / ri_1);
                if (x < ri_1) t = 0.0;
                else if (x < ri) t = 0.5 * (dx - Math.Log(dx) - 1.0);
                else
                    t = 0.5 * (Math.Log(dx) * (d - 1.0) + d * (1.0 - Math.Log(d)) - 1.0);
                return ri * t;
            }

        }


        public double FiR1p(int i, double x)
        {
            double r1, ri_1, ri, t, dx, d;
            if (i == 1)
            {
                r1 = h; dx = (x / r1) / r1;
                if (x < r1) t = dx;
                else t = 1.0 / x;
                return r1 * t;
            }
            else
            {
                ri_1 = (i - 1) * h; ri = i * h; dx = (x / ri_1) / ri_1; d = (ri / ri_1) * (ri / ri_1);
                if (x < ri_1) t = 0.0;
                else if (x < ri) t = (dx - 1.0 / x);
                else
                    t = (d - 1.0) / x;
                return ri * t;
            }

        }

        public double FikR1(int i, int k)
        {
            double x;
            x = a1 + k * h;
            return p1(x) * FiR1p(i, x) + q1(x) * FiR1(i, x);
        }

        public void LambdaR1(double[] x)
        {
            int i, k; double y, f, s;
          //  x[0] = 0.0;
            for (k = 1; k < n; k++)
            {
                y = a1 + k * h;
                f = fg1(y) - re1(a1) * q1(y);
                s = 0.0;
                for (i = 1; i < k; i++) //k-1 on k
                    s = s + FikR1(i, k) * x[i];
                x[k] = (f - s) / FikR1(k, k); //FkR(k);
            }
        }


        public double SummaR1(double[] x, double y)//стр.137
        {
            int i; double s;
            s = 0.0;
            for (i = 1; i < n; i++)
            {
                s = s + FiR1(i, y) * x[i];
            };
            return s + re1(a1);
        }



        public double f1(double x, double y)
        {
            double ad = 1.0; double bd = 1.0;
            switch (primer1)
            {
                case 1: return x * Math.Exp(-x*x) - 2.0 * x * y;
                case 2: return 0.5 * Math.Sin(2.0 * x) - Math.Cos(x) * y;
                case 3: return Math.Exp(-Math.Sin(x)) - Math.Cos(x) * y;
                case 4: return Math.Sin(2.0*x) - Math.Tan(x) * y;
                case 5: return Math.Exp(+bd * x) - ad * y;
                case 6: return FDUp(x) * FDU(x) - FDUp(x) * y; 
                default:
                    MessageBox.Show("sorry, primer");
                    return 0.0;
            }
        }

        public void RungeKutta1(double[] x)
        {
            int k; double k1, k2, k3, k4;
            double y = a1; double u = re1(a1); 
            for (k = 0; k < n; k++)
            {
                x[k] = u; 
                k1 = f1(y, u);
                k2 = f1(y + h / 2.0, u + h * k1 / 2.0);
                k3 = f1(y + h / 2.0, u + h * k2 / 2.0);
                k4 = f1(y + h, u + h * k3);
                u = u + h * (k1 + 2.0 * k2 + 2.0 * k3 + k4) / 6.0;
                y = y + h;
            }
        }

        public double FiR3(int i, double x)
        {
            double r1, ri_1, ri, t, dx, d;
            if (i == 1)
            {
                r1 = h; dx = (x / r1) * (x / r1);
                if (x < r1) t = dx;
                else t = 0.5*(4.0 - 2.0/dx);
                return t;
            }
            else
            {
                ri_1 = (i - 1) * h; ri = i * h; dx = (x / ri_1) * (x / ri_1); d = (ri / ri_1) * (ri / ri_1);
                if (x < ri_1) t = 0.0;
                else if (x < ri) t = 0.5 * (dx - Math.Log(dx) - 1.0);
                else
                    t = 0.5 * (Math.Log(dx) * (d - 1.0) + d * (1.0 - Math.Log(d)) - 1.0);
                return ri * t;
            }

        }

        public double FiR3p(int i, double x)
        {
            double r1, ri_1, ri, t, dx, d2x, d3x, d;
            if (i == 1)
            {
                r1 = h; dx = (x / r1); d2x = dx * dx; d3x = dx * d2x;
                if (x < r1) t = dx;
                else t = 1.0/d3x;
                return t;
            }
            else
            {
                ri_1 = (i - 1) * h; ri = i * h; dx = (x / ri_1) * (x / ri_1); d = (ri / ri_1) * (ri / ri_1);
                if (x < ri_1) t = 0.0;
                else if (x < ri) t = 0.5 * (dx - Math.Log(dx) - 1.0);
                else
                    t = 0.5 * (Math.Log(dx) * (d - 1.0) + d * (1.0 - Math.Log(d)) - 1.0);
                return ri * t;
            }
        }

//********************************************************************************************************

        public void MatrixVectS(double[] alf, double[] bet, double[] gam, double[] b)
        {
            int i;
            for (i = 1; i <= (n - 2); i++)
            { alf[i - 1] = 2.0 / 3.0; b[i - 1] = (x[i - 1] - 2.0 * x[i] + x[i + 1]) / h / h; };
            for (i = 1; i <= (n - 3); i++)
            { bet[i - 1] = 1.0 / 6.0; gam[i - 1] = 1.0 / 6.0; };
            bet[n - 3] = 0.0; gam[n - 3] = 0.0;
            MessageBox.Show("MatrixVectS n = " + n.ToString());
            return;
        }

        //public void GaussS3(double[] alf, double[] bet, double[] gam, double[] b, double[] m)
        //{
        //    int i;
        //    for (i = 1; i <= (n - 3); i++)
        //    {
        //        alf[i] = alf[i] - bet[i - 1] * gam[i - 1] / alf[i - 1];
        //        b[i] = b[i] - bet[i - 1] * b[i - 1] / alf[i - 1];
        //    }
        //    m[n - 3] = b[n - 3] / alf[n - 3];
        //    for (i = (n - 4); i >= 0; i--) m[i] = (b[i] - gam[i] * m[i + 1]) / alf[i];
        //    MessageBox.Show("Hello GaussS3 n = " + n.ToString());
        //    return;
        //}

        public double SummaS3(double y, double[] x, double[] bs, double[] cs, double[] ds)
        {
            int i; double r, s;
            for (i = 0; i <= (n - 2); i++)
            {
                if (i == 0) { bs[0] = (x[1] - x[0]) / h - h / 6.0 * m[0]; cs[0] = 0.0; ds[0] = m[0] / 6.0 / h; }
                else
                { bs[i] = (x[i + 1] - x[i]) / h - h / 6.0 * (m[i] + 2.0 * m[i - 1]); cs[i] = m[i - 1] / 2.0; 
                    ds[i] = (m[i] - m[i - 1]) / 6.0 / h; };
            };
            i = (int)((y - a1) / h);
            if (i == (n - 1)) return x[n - 1];
            else
            {
                r = y - (a1 + i * h);
                s = x[i] + bs[i] * r + cs[i] * r * r + ds[i] * r * r * r;
                return s;
            }
        }
         
        public void Tabulation(int[] xp, int[] yp, int[] zp)//стр.137
        {
            int k;
            double y, NormC, NormL2, s, h, yd, yr, ymas, zmax, ymax, zmin, ymin, xg, yg, zg;
            y = a1; NormC = -1.0; s = 0;
            ymas = -1.0;
            double z = (double)(ng - 1);
            h = (b1 - a1) / z;
            if ((KeyOfJob == 1) && (NumberMethod == 1)) 
            {
                RungeKutta1(x);
                MatrixVectS(alf, bet, gam, b);
                GaussS3(alf, bet, gam, b, m);
            }
            else
                if ((KeyOfJob == 1) && (NumberMethod == 2)) 
            {
                LambdaP1(x);
            }
            else
                if ((KeyOfJob == 1) && (NumberMethod == 3)) 
            {
                LambdaR1(x);
            }
            else
                if ((KeyOfJob == 2) && (NumberMethod == 1))
            {
                RungeKutta2(x);
                MatrixVectS(alf, bet, gam, b);
                GaussS3(alf, bet, gam, b, m);
            }
            else
                if ((KeyOfJob == 2) && (NumberMethod == 2))
                {
                    LambdaP2(x);
                }
            else
                    if ((KeyOfJob == 2) && (NumberMethod == 3))
                {
                    LambdaR2(x);
                }
  
            for (k = 0; k < ng; k++)
            {
                xg = y;
                if ((KeyOfJob == 1) && (NumberMethod == 1)) { yg = re1(y); zg = SummaS3(y, x, bs, cs, ds); }
                else
                    if ((KeyOfJob == 2) && (NumberMethod == 1)) { yg = re2(y); zg = SummaS3(y, x, bs, cs, ds); }
                    else
                        if ((KeyOfJob == 1) && (NumberMethod == 2)) { yg = re1(y); zg = SummaP1(x, y); }
                        else
                            if ((KeyOfJob == 2) && (NumberMethod == 2)) { yg = re2(y); zg = SummaP2(x, y); }
                            else
                                if ((KeyOfJob == 1) && (NumberMethod == 3)) { yg = re1(y); zg = SummaR1(x, y); }
                                else
                                    if ((KeyOfJob == 2) && (NumberMethod == 3)) { yg = re2(y); zg = SummaR2(x, y); }
                                    else
                                       { yg = FiR3p(1, y); zg = 0.0; }

                if (Math.Abs(yg) > Math.Abs(zg))
                    yd = Math.Abs(yg);
                else
                    yd = Math.Abs(zg);
                if (yd > ymas)
                    ymas = yd;
                y = y + h;
            }

            ymax = ymas + 0.1 * ymas;
            ymin = -ymax;
            zmax = ymax;
            zmin = ymin;

            y = a1;
            ymas = -1.0;
            for (k = 0; k < ng; k++)
            {
                xg = y;
                if ((KeyOfJob == 1) && (NumberMethod == 1)) { yg = re1(y); zg = SummaS3(y, x, bs, cs, ds); }
                else
                    if ((KeyOfJob == 2) && (NumberMethod == 1)) { yg = re2(y); zg = SummaS3(y, x, bs, cs, ds); }
                    else
                        if ((KeyOfJob == 1) && (NumberMethod == 2)) { yg = re1(y); zg = SummaP1(x, y); }
                        else
                            if ((KeyOfJob == 2) && (NumberMethod == 2)) { yg = re2(y); zg = SummaP2(x, y); }
                            else
                                if ((KeyOfJob == 1) && (NumberMethod == 3)) { yg = re1(y); zg = SummaR1(x, y); }
                                else
                                    if ((KeyOfJob == 2) && (NumberMethod == 3)) { yg = re2(y); zg = SummaR2(x, y); }
                                    else
                                            { yg = FiR3p(1, y); zg = 0.0; }
               
                {
                    yr = Math.Abs(yg - zg);
                    if (yr > NormC)
                        NormC = yr;
                    s = s + yr * yr;
                }

                xp[k] = (int)(1024 / (b1 - a1) * (xg - a1));
                yp[k] = 780 - (int)(780 / (ymax - ymin) * (yg - ymin));
                zp[k] = 780 - (int)(780 / (zmax - zmin) * (zg - zmin));
                y = y + h;
            }

            Number = n;
            Rangemin = a1;
            Rangemax = b1;
            NumberGr = ng;
            NormL2 = Math.Sqrt(s / z);
            Xcoord = xp;
            Ycoord = yp;
            Zcoord = zp;
            MessageBox.Show("NormC = : " + NormC.ToString());
            MessageBox.Show("NormL2 = : " + NormL2.ToString());

            //		        cout <<"NormC="<<NormC<<"   "<<"NormL2="<<NormL2<<"   "<<"a1="<<a1<<"   "<<"ymin="<<ymin<<"   ";
            //		        cout <<'\n';
        }
    }
}
