using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using BaseLibrary;

namespace Spline1
{
    public partial class Form1 : Form
    {

        SystemEquation systemEquation = new SystemEquation();

        public Form1()
        {
            InitializeComponent();

            System.Globalization.NumberFormatInfo provider = new System.Globalization.NumberFormatInfo();
            provider.NumberDecimalSeparator = ",";
            provider.NumberGroupSeparator = " ";
            provider.NumberGroupSizes = new int[] { 3 };

            this.textBox1.Text = "-1.0";
            this.textBox2.Text = "1.0";
            this.textBox3.Text = systemEquation.Number.ToString();
            this.textBox3.Text = BasicFunctionClass.n.ToString();

            string str = this.textBox1.Text;
            str = str.Replace('.', ',');
            systemEquation.Rangemin = Convert.ToDouble(str, provider);
            str = this.textBox2.Text;
            str = str.Replace('.', ',');
            systemEquation.Rangemax = Convert.ToDouble(str, provider);

            comboBox1.SelectedItem = "5";
            comboBox2.SelectedItem = "3";
            comboBox3.SelectedItem = "0";
            comboBox4.SelectedItem = "1";
            comboBox5.SelectedItem = "1";
            this.textBox8.Text = "10.0";
        }

        private void button1_Click(object sender, EventArgs e)
        {
            System.Globalization.NumberFormatInfo provider = new System.Globalization.NumberFormatInfo();
            provider.NumberDecimalSeparator = ",";
            provider.NumberGroupSeparator = " ";
            provider.NumberGroupSizes = new int[] { 3 };

            string str = this.textBox1.Text;
            str = str.Replace('.', ',');
            systemEquation.Rangemin = Convert.ToDouble(str, provider);
            str = this.textBox2.Text;
            str = str.Replace('.', ',');
            systemEquation.Rangemax = Convert.ToDouble(str, provider);

            systemEquation.TypeOfBasicElement = comboBox1.SelectedIndex + 1;
            systemEquation.PowerOfBasicElement = comboBox2.SelectedIndex;
            bool ret = CheckPowerOfBasic(systemEquation.TypeOfBasicElement, systemEquation.PowerOfBasicElement);
            if (ret == false)
                return;

            systemEquation.Number = Convert.ToInt32(this.textBox3.Text);
            int num = systemEquation.Number;
            if (num < 5 || num > BasicFunctionClass.N)
            {
                MessageBox.Show("   .   1 : " + BasicFunctionClass.N.ToString());
                return;
            }

            systemEquation.Number = num;
            systemEquation.h = (systemEquation.Rangemax - systemEquation.Rangemin) / (double)(num - 1);

            if (systemEquation.TypeOfBasicElement < 1 || systemEquation.TypeOfBasicElement > 23)
            {
                MessageBox.Show("  .   1 : 23");
                return;
            }
            if (systemEquation.PowerOfBasicElement < 0 || systemEquation.PowerOfBasicElement > 11)
            {
                MessageBox.Show("  .   0 : 11");
                return;
            }

            str = this.textBox8.Text;
            str = str.Replace('.', ',');
            systemEquation.WidthOfBasicElement = Convert.ToDouble(str, provider);
            if (systemEquation.WidthOfBasicElement < 1.0)
            {
                MessageBox.Show("    .\n      1.0");
                return;

            }

            systemEquation.MethodSLAY = comboBox5.SelectedIndex + 1;

            if (systemEquation.MethodSLAY < 1 || systemEquation.MethodSLAY > 5)
            {
                MessageBox.Show("   .   1 : 3");
                return;
            }

            BasicFunctionClass.KeyOfJob = comboBox3.SelectedIndex;
            if (BasicFunctionClass.KeyOfJob < 0 || BasicFunctionClass.KeyOfJob > 3)
            {
                MessageBox.Show("     .   0 : 3");
                return;
            }
            if (BasicFunctionClass.KeyOfJob == 1)
            {
                if (BasicFunctionClass.n > 41)
                {
                    MessageBox.Show("   .      41");
                    return;
                }
            }
            BasicFunctionClass.primer = comboBox4.SelectedIndex + 1;
            if (BasicFunctionClass.primer < 1 || BasicFunctionClass.primer > 9)
            {
                MessageBox.Show("     1 : 9");
                return;
            }

            if ((systemEquation.TypeOfBasicElement < 5) && (BasicFunctionClass.KeyOfJob == 0)) 
            {
                systemEquation.Tabulation(systemEquation.xp, systemEquation.yp, systemEquation.zp);
            }
            else
            {
                if (systemEquation.MethodSLAY == 1)  
                {
                    if (BasicFunctionClass.KeyOfJob == 0)
                    {
                        systemEquation.MatrixVectf(BasicFunctionClass.a, systemEquation.b);
                        BasicFunctionClass.Gauss(BasicFunctionClass.n, BasicFunctionClass.a, systemEquation.b, systemEquation.x);
                        systemEquation.Tabulation(systemEquation.xp, systemEquation.yp, systemEquation.zp);
                    }
                    else
                    {
                        if (BasicFunctionClass.KeyOfJob == 1)
                        {
                            systemEquation.MatrixVect2(BasicFunctionClass.a, systemEquation.b);
                            int n2 = BasicFunctionClass.n * BasicFunctionClass.n;
                            BasicFunctionClass.Gauss(n2, BasicFunctionClass.a, systemEquation.b, systemEquation.x);
                            systemEquation.Tabulation(systemEquation.xp, systemEquation.yp, systemEquation.zp);
                        }
                        else
                        {
                            if (BasicFunctionClass.KeyOfJob == 2)
                            {
                                systemEquation.Tabulation(systemEquation.xp, systemEquation.yp, systemEquation.zp);
                            }
                            else
                            {
                                systemEquation.Tabulation(systemEquation.xp, systemEquation.yp, systemEquation.zp);
                            }
                        }
                    }
                }
                else
                    if (systemEquation.MethodSLAY == 2)  
                    {
                        systemEquation.MatrixVectf(BasicFunctionClass.a, systemEquation.b);
                        BasicFunctionClass.Decomp(BasicFunctionClass.a, ref BasicFunctionClass.cond, BasicFunctionClass.ipvt,
                        BasicFunctionClass.work);

                        MessageBox.Show("Cond : " + BasicFunctionClass.cond.ToString());

                        BasicFunctionClass.Solve(BasicFunctionClass.a, systemEquation.b, BasicFunctionClass.ipvt);
                        systemEquation.Tabulation(systemEquation.xp, systemEquation.yp, systemEquation.zp);
                    }
                    else
                        if (systemEquation.MethodSLAY == 3)  
                        {
                            systemEquation.MatrixVectf(BasicFunctionClass.a, systemEquation.b);
                            BasicFunctionClass.Zeidel(BasicFunctionClass.n, BasicFunctionClass.a, systemEquation.b, systemEquation.x);
                            systemEquation.Tabulation(systemEquation.xp, systemEquation.yp, systemEquation.zp);
                        }
            }
            Form2 frm = new Form2();
            frm.Show();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private bool CheckPowerOfBasic(int type, int power)
        {
            int[] p5 = { 1, 3, 5, 7, 9, 11 };
            int[] p8 = { 0, 1, 2, 3};
            int[] p9 = { 1, 3 };
            int[] p10 = { 1, 2, 3 };
            int[] p11 = { 1, 2 };
            int[] p12 = { 3, 5 };
            int[] p13 = { 3, 5 };
            int[] p14 = { 2, 3 };
            int[] p15 = { 1, 2 };
            int[] p16 = { 0, 1 };
            int[] p17 = { 1, 2, 3 };
            int[] p21 = { 1, 2 };
            bool ret = true;
            switch (type)
            {
                case 5:
                    ret = CheckPowerByType(p5, type, power);
                    break;
                case 8:
                    ret = CheckPowerByType(p8, type, power);
                    break;
                case 9:
                    ret = CheckPowerByType(p9, type, power);
                    break;
                case 10:
                    ret = CheckPowerByType(p10, type, power);
                    break;
                case 11:
                    ret = CheckPowerByType(p11, type, power);
                    break;
                case 12:
                    ret = CheckPowerByType(p12, type, power);
                    break;
                case 13:
                    ret = CheckPowerByType(p13, type, power);
                    break;
                case 14:
                    ret = CheckPowerByType(p14, type, power);
                    break;
                case 15:
                    ret = CheckPowerByType(p15, type, power);
                    break;
                case 16:
                    ret = CheckPowerByType(p16, type, power);
                    break;
                case 17:
                    ret = CheckPowerByType(p17, type, power);
                    break;
                case 21:
                    ret = CheckPowerByType(p21, type, power);
                    break;
                default:
                    break;
            }

            return ret;
        }

        private bool CheckPowerByType(int[] p, int type, int power)
        {
            string mes = "";
            for (int i = 0; i < p.Length; i++)
            {
                mes = mes + " " + p[i].ToString();
            }
            bool find = false;
            for (int i = 0; i < p.Length; i++)
            {
                if (power == p[i])
                {
                    find = true;
                    break;
                }
            }
            if (find == false)
            {
                MessageBox.Show("   " + type.ToString() + ".     .\n   : " + mes);
                return false;
            }
            return true;
        }
    }
}