using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using BaseLibrary;

namespace Spline2
{
    public partial class Form1 : Form
    {

        IntegralEquation integralEquation = new IntegralEquation();

        public Form1()
        {
            System.Globalization.NumberFormatInfo provider = new System.Globalization.NumberFormatInfo();
            provider.NumberDecimalSeparator = ",";
            provider.NumberGroupSeparator = " ";
            provider.NumberGroupSizes = new int[] { 3 };

            InitializeComponent();

            this.textBox1.Text = "-1.0";
            this.textBox2.Text = "1.0";

            string str = this.textBox1.Text;
            str = str.Replace('.', ',');
            integralEquation.Rangemin = Convert.ToDouble(str, provider);
            str = this.textBox2.Text;
            str = str.Replace('.', ',');
            integralEquation.Rangemax = Convert.ToDouble(str, provider);
            this.textBox1.Enabled = false;
            this.textBox2.Enabled = false;
            this.textBox3.Text = integralEquation.Number.ToString();
            this.textBox4.Text = "0.000000000";
            this.textBox8.Text = "0.000000001";

            str = this.textBox4.Text; str = str.Replace('.', ',');
            integralEquation.AlfaCoPr0 = Convert.ToDouble(str, provider);
            str = this.textBox8.Text; str = str.Replace('.', ',');
            integralEquation.AlfaANT = Convert.ToDouble(str, provider);

            comboBox1.SelectedItem = "1";
            comboBox2.SelectedItem = "1";
            comboBox5.SelectedItem = "0";
        }

        private void button1_Click(object sender, EventArgs e)
        {
            System.Globalization.NumberFormatInfo provider = new System.Globalization.NumberFormatInfo();
            provider.NumberDecimalSeparator = ",";
            provider.NumberGroupSeparator = " ";
            provider.NumberGroupSizes = new int[] { 3 };

            BasicFunctionClass.primer = comboBox1.SelectedIndex + 1;
            integralEquation.Key123 = comboBox2.SelectedIndex + 1;
            BasicFunctionClass.KeyOfJob = comboBox5.SelectedIndex;
            integralEquation.Number = Convert.ToInt32(this.textBox3.Text);
            int num = integralEquation.Number;

            if (num < 5 || num > BasicFunctionClass.N)
            {
                MessageBox.Show("   .   5 : " + BasicFunctionClass.N.ToString());
                return;
            }
            integralEquation.h = (integralEquation.Rangemax - integralEquation.Rangemin) / (double)(num - 1);

            string str = this.textBox4.Text; str = str.Replace('.', ',');
            integralEquation.AlfaCoPr0 = Convert.ToDouble(str, provider);
            str = this.textBox8.Text; str = str.Replace('.', ',');
            integralEquation.AlfaANT = Convert.ToDouble(str, provider);

            if (BasicFunctionClass.KeyOfJob == 0)
            {
                integralEquation.MatrixVectf(BasicFunctionClass.a, integralEquation.b, 
                integralEquation.Key123);
                BasicFunctionClass.Decomp(BasicFunctionClass.a, ref BasicFunctionClass.cond, BasicFunctionClass.ipvt, BasicFunctionClass.work);
                BasicFunctionClass.Solve(BasicFunctionClass.a, integralEquation.b, BasicFunctionClass.ipvt);
            }
            else 
                if (BasicFunctionClass.KeyOfJob == 2)
                {
                    integralEquation.MatrixVectT(BasicFunctionClass.a, integralEquation.b, 
                    integralEquation.Key123);
                    BasicFunctionClass.Decomp(BasicFunctionClass.a, ref BasicFunctionClass.cond, BasicFunctionClass.ipvt, BasicFunctionClass.work);
                    BasicFunctionClass.Solve(BasicFunctionClass.a, integralEquation.b, BasicFunctionClass.ipvt);
                }

            integralEquation.Tabulation(integralEquation.xp, integralEquation.yp, integralEquation.zp);
            Form2 frm = new Form2();
            frm.Show();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}