using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using BaseLibrary;

namespace Spline5
{
    public partial class Form1 : Form
    {

        InterpolationLocal interpolationLocal = new InterpolationLocal();

        public Form1()
        {
            InitializeComponent();


            this.textBox1.Text = interpolationLocal.Rangemin.ToString();
            this.textBox2.Text = interpolationLocal.Rangemax.ToString();
            this.textBox3.Text = interpolationLocal.Number.ToString();
            comboBox1.SelectedItem = "1";
            comboBox2.SelectedItem = "1";
            comboBox3.SelectedItem = "1";

            this.textBox1.Text = "-1.0";
            this.textBox2.Text = "1.0";
            this.textBox1.Enabled = false;
            this.textBox2.Enabled = false;

        }

        private void button1_Click(object sender, EventArgs e)
        {
            System.Globalization.NumberFormatInfo provider = new System.Globalization.NumberFormatInfo();
            provider.NumberDecimalSeparator = ",";
            provider.NumberGroupSeparator = " ";
            provider.NumberGroupSizes = new int[] { 3 };

            BasicFunctionClass.primer = comboBox1.SelectedIndex + 1;
            interpolationLocal.Number = Convert.ToInt32(this.textBox3.Text);

            BasicFunctionClass.KeyOfJob = Convert.ToInt32(comboBox3.SelectedItem);

            int num = interpolationLocal.Number;
            if (num < 5 || num > BasicFunctionClass.N)
            {
                MessageBox.Show("   .   5 : " + BasicFunctionClass.N.ToString());
                return;
            }

            string str = this.textBox1.Text;
            str = str.Replace('.', ',');
            interpolationLocal.Rangemin = Convert.ToDouble(str, provider);
            str = this.textBox2.Text;
            str = str.Replace('.', ',');
            interpolationLocal.Rangemax = Convert.ToDouble(str, provider);

            interpolationLocal.h = (interpolationLocal.Rangemax - interpolationLocal.Rangemin) / (double)(num - 1);

            interpolationLocal.TypeOfBasicElement = comboBox2.SelectedIndex + 1;
            interpolationLocal.Tabulation(interpolationLocal.xp, interpolationLocal.yp, interpolationLocal.zp);

            Form2 frm = new Form2();
            frm.Show();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.Close();
        }

    }
}