// test.cpp : Defines the entry point for the console application.
//
#include "stdafx.h"
#include <math.h>
#include <iostream>
#include <conio.h>
//#using <mscorlib.dll>
//#include <graphics:drawing:system>
//#include <forms:windows:system>
using namespace std;
const int n=101; const int ng=640; //   n=ng
const double pi=3.1415926535897932385;
const double a1=-1.0; const double b1=1.0; //   
const double z=double(n-1); const double h=(b1-a1)/z; 
const int pr=5;//    
const int kmax=10001;const double eps=0.00000001;// -       .
const int setka=0; //    .
const double al=500.0; const int st=2; const int stloc=4; const double dloc=25.0; //  : 
//Corr3 (al=115,   al=180.0),
// (al=25.0,st=2,   n=ng=105;  : st=3,stloc=4,dloc=al=25.0).
const int SpB=2;//   -
		const int nf=1000;const int ny=25;	const int nx=25; ;//   
		const int kluchIU_1_2=2; //   
		const int CL_1_2=1;//    
		const double epsIU=0.00000;													const int primIU=5;	
								const int primerg=20;	const int primer=1;		const int method_approx=19;																				;
		//1-S3 spline 
		//2-B spline,SpB=3  3-,SpB=2  2-      n=ng. 
		//3-polinom algebraiqe,setka=0:,setka=1:. 
		//4-polinom trigonometriqe
		//5-A3 spline
		//6-Corr3.spline,  1.0<al<  .  al=115.0; 
		//7-In3 spline (,   al=750)
		//8-In2 spline ()
		//9- ,  al>1.0,st=2,3,...  .   al=25.0,st=3; 
		//10- .    5.
		//11- .    7.      n=255.

																		   const int method_RSLAE=1;
//  
		//1-Gauss
		//2-Gauss-Jordan
		//3-Zeidel, rabotaet c Corr3, al=2.0, . , al=10.0;

int i,j,k,m;
double a[n][n];
double b[n],x[n];
double c[n];
int xp[ng],yp[ng],zp[ng];
double alf[n],bet[n],gam[n];
double bs[n],cs[n],ds[n],es[n];

double sgn(double x)
{
	if (x<0.0) return -1.0;
	else if (x>0.0)return 1.0;
	else return 0.0;
}
double step(int n,double x)
{
	if (n<0) return 0.0; else 
	switch (n)
	{
	case 0: return 1.0;
	case 1: return x;
	default: return x*step(n-1,x);
	}
}
	double Tch(int pr,double x)
{
	int i; double p,q,r;
	if (pr<0) printf("sorry, n<0", cout <<'\n');
	switch (pr)
	{
	case 0: return 1.0;
	case 1: return x;
	default: 
			 {
				p=1.0;q=x;
				for (i=2;i<=pr;i++) {r=2.0*x*q-p;p=q;q=r;};
				return r;
			 };
	}
}
	double Stu(int st,double x)
	{
	return 1.0/step(st,1.0+x*x/(2.0*st-1.0));
	}
	
	double f1(int pr,double x,double y)
	{
	return cos(x*sin(y)-pr*y)/pi;
	}

	double Bessel(int pr,double x)
{
	int i,n1; double y,s1,s2,h;

	n1=15;h=pi/(2.0*n1);s2=0.0; s1=f1(pr,x,pi-h);y=0.0;
	for (i=1;i<n1;i++)
		{
		y=y+h;s1=s1+f1(pr,x,y);
		y=y+h;s2=s2+f1(pr,x,y);
		};
	return (f1(pr,x,0.0)+f1(pr,x,pi)+4.0*s1+2.0*s2)*h/3.0;
}
	double f2(double x,double y)
	{
	return sqrt(1.0-x*x*sin(y)*sin(y));
	}
/*
	double E(double x)
{
	int i,n1; double y,s1,s2,h;

	n1=5;h=pi/2.0/(2.0*n1);s2=0.0; s1=f2(x,pi/2.0-h);y=0.0;
	for (i=1;i<n1;i++)
		{
		y=y+h;s1=s1+f2(x,y);
		y=y+h;s2=s2+f2(x,y);
		};
	return (f2(x,0)+f2(x,pi/2.0)+4.0*s1+2.0*s2)*h/3.0;
}
*/


	double E(double x)
{
	double c,d,a,b,s,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,w1,w2,w3,w4,w5,w6,w7,w8,w9,w10;
	c=0.0;d=pi/2.0;
	x6=0.148874338981631;x7=0.433395394129247;x8=0.679409568299024;x9=0.865063366688985;
	x10=0.973906528517172;x1=-x10;x2=-x9;x3=-x8;x4=-x7;x5=-x6;
	w6=0.295524224714753;w7=0.269266719309996;w8=0.219086362515982;w9=0.149451349150581;
	w10=0.066671344308688;w1=w10;w2=w9;w3=w8;w4=w7;w5=w6;
	a=(d-c)/2.0;b=(c+d)/2.0;
	x1=a*x1+b;x2=a*x2+b;x3=a*x3+b;x4=a*x4+b;x5=a*x5+b;
	x6=a*x6+b;x7=a*x7+b;x8=a*x8+b;x9=a*x9+b;x10=a*x10+b;
	s=w1*f2(x,x1)+w2*f2(x,x2)+w3*f2(x,x3)+w4*f2(x,x4)+w5*f2(x,x5)+
	w6*f2(x,x6)+w7*f2(x,x7)+w8*f2(x,x8)+w9*f2(x,x9)+w10*f2(x,x10);
	return a*s;
}

double Sp_B3(double x)
	{
		double p=fabs(x);double q=1.0-p;double r=2.0-p;
		if (p>2.0)return 0.0;
		else if (p>1.0)return r*r*r/6.0;
		else return (1.0+3.0*q+3.0*q*q-3.0*q*q*q)/6.0;
	};
double Sp_B2(double x)
	{
		double p=fabs(x);
		if (p>1.5)return 0.0;
		else if (p>0.5)return (p-1.5)*(p-1.5)/2.0;
		else return 0.75-p*p;
	};
double Sp_O2(double x)
	{
		double p=step(2,(1.0+x));double q=step(2,(1.0-x));
		if (x<-1.0)return 0.0;
		else if (x<0.0)return p/2.0;
		else if (x<1.0)return 1-q/2.0;
		else return 1.0;
	};
double ArctX(double x)
	{
	double k,s,t,a,y,eps;
	eps=0.0000001;
	k=0.0; y=fabs(x);
		if (y>1.0) {a=1.0/y;s=1.0/y;}
	else {s=y;a=y;};
	do  
	{
	if (y>1.0) {t=-step(2,(2.0*k+1.0)/(2.0*k+3.0)/y); a=a*t;s=s+a;k=k+1.0;}
	else {t=-step(2,(2.0*k+1.0)/(2.0*k+3.0)*y);a=a*t;s=s+a;k=k+1.0;}
	}
	while (fabs(a)>eps);
	if (y>1.0) s=s+pi/2.0*log(y);
	if (x<0.0) s=-s;
	m=int(k);
	return s;
	};
	double Erf(double x)
{
	double y,a1,a2,a3,a4,a5,p,t,z,r;
	p=0.3275911; a1=0.254829592; a2=-0.284496736;a3=1.421413741;a4=-1.453152027;
	a5=1.061405429; y=fabs(x);t=1.0/(1+p*y);if (y>10.0) z=0.0; else z=exp(-y*y);
	r=1.0-(a1*t+a2*t*t+a3*step(3,t)+a4*step(4,t)+a5*step(5,t))*z;
	if (x<0.0) r=-r;
	return r;
}
double BasInt(double x)
	{
		double p=fabs(x);
		if (p>1.0)return 0.5*sgn(x);
		else return x-0.5*sgn(x)*x*x;
	};
double FNlocDel(double x)
{
	double p,q,d,FN,FNlD;
	p=fabs(x);d=sqrt(6.0);q=(p*p-d*d);
	if (p>10.0) FN=0.0; 
	else FN=exp(-p*p/2.0)/sqrt(2.0*pi);
	if (p>d) FNlD=0.0; 
	else FNlD=FN*q*q*q;
	return FNlD;
}
double Stuloc(int st,int stloc,double x)
	{
	double p,q,d,FS,FSlD;
	p=fabs(x);d=sqrt(dloc);q=(p*p-d*d);
	FS=Stu(st,p);
	if (p>d) FSlD=0.0; 
	else FSlD=FS*step(stloc,q);
	return FSlD;
	}
double Cloc(int nl)
{
	int i; double a2,b2,d,h,s1,s2,y;
	d=sqrt(6.0);a2=-d;b2=d;
	h=(b2-a2)/(2.0*nl);s2=0.0;s1=FNlocDel(b2-h);y=a2;
	for (i=1;i<nl;i++)
		{
		y=y+h;s1=s1+FNlocDel(y);
		y=y+h;s2=s2+FNlocDel(y);
		};
	return (FNlocDel(a2)+FNlocDel(b2)+4.0*s1+2.0*s2)*h/3.0;
}
double f(double x)
{
	switch (primer)
	{
	case 1: return 1/(1+25*x*x);
	case 2: return sin(pi*x);
	case 3: return exp(cos(pi*x));
	case 4: return sgn(x)*step(2,x)*(x-a1)*(x-b1);
	case 5: return fabs(x);
	case 6: return (fabs(x)<0.5)? 1.0:0.0;
	case 7: return (SpB==3)? Sp_B3(x/2.0):Sp_B2(x/2.0);
	case 8: return Tch(pr,x);
	case 9: return Bessel(pr,x);
	case 10: return ArctX(x);
	case 11: return Erf(x);
	default: return printf("sorry, primer", cout <<'\n');
	}
}

double xi(int i)
{
	switch (method_approx)
	{
	case 1: return cos((2.0*i+1.0)*pi/(2.0*n)); 
	case 2: return a1+i*h;
		//2.0*i*pi/(2.0*n+1);
	case 3: return a1+(b1-a1)/(n+1)*(i+1); 
		//(2.0*i+1)*pi/2.0/(n+1);
	case 4: return (i+1)*pi/(n+1);
	case 5: return a1+i*h;
	case 6: return a1+i*h;
	case 7: return a1+i*h;
	case 8: return a1+i*h;
	case 9: return a1+i*h;
	case 10: return a1+i*h;
	case 11: return a1+i*h;
	case 12: return a1+i*h;
	case 13: return a1+i*h;
	case 14: return a1+i*h;
	case 15: return a1+i*h;
	case 16: return a1+i*h;
	case 17: return a1+i*h;
	case 18: return a1+i*h;

	default: return printf("sorry 1, bad parameter method_approx", cout <<'\n');
	}
}
double Ylin(double x)
	{
	return f(a1)+(f(b1)-f(a1))/(b1-a1)*(x-a1);
	}
double Lagr(int i,double x)
{
	int k; double p;

	p=1.0;
	for (k=0;k<n;k++)
		{
		if (k!=i) p=p*(x-xi(k))/(xi(i)-xi(k));
		};
	return p;
}
double Trig(int i,double x)
{
	int k; double p;

	p=1.0;
	for (k=-n;k<=n;k++)
		{
		if (k!=i) p=p*sin((x-xi(k))/2.0)/sin((xi(i)-xi(k))/2.0);
		};
	return p;
}
double Tcos(int i,double x)
{
	int k; double p;
	p=1.0;
	for (k=0;k<=n;k++) 
		{
		if (k!=i) p=p*(cos(x)-cos(xi(k)))/(cos(xi(i))-cos(xi(k)));
		};
	return p;
}
double Tsin(int i,double x)
{
	int k; double p;
	p=1.0;
	for (k=0;k<=(n-1);k++) 
		{
		if (k!=i) p=p*(cos(x)-cos(xi(k)))/(cos(xi(i))-cos(xi(k)));
		};
	p=p*sin(x)/sin(xi(i));
	return p;
}
double NDel(int i,double x)
{
	double p,ND;
	p=(x-xi(i))/h;
	if (p>10.0) ND=0.0; 
	else ND=exp(-p*p/2.0)/sqrt(2.0*pi);
	return ND;
}
double LDel(int i,double x)
{
	double p,LD;
	p=fabs((x-xi(i))/h);
	if (p>50.0) LD=0.0; 
	else LD=(3.0/16.0)*(1.0+p+p*p/3.0)*exp(-p);
	return LD;
}
double NlocDel(int i,double x)
{
	double p;
	p=(x-xi(i))/h;
	return 1.0/Cloc(10)*FNlocDel(p);
}
double ErfSt(int i,double x)
{
	double p;
	p=(x-xi(i))/h;
	return (Erf((p+0.5)/sqrt(2.0))-Erf((p-0.5)/sqrt(2.0)))/2.0;
}
double Erff(double x)
{
	double p,q;
	p=x*x; if (p>100.0) q=0.0; else q=exp(-p)/sqrt(pi); 
	return x*Erf(x)+q;
}
double ErfKr(int i,double x)
{
	double p;
	p=(x-xi(i))/h; 
	return (Erff((p+1.0)/sqrt(2.0))+Erff((p-1.0)/sqrt(2.0))-2.0*Erff(p/sqrt(2.0)))/sqrt(2.0);
}
double Expp(double x)
{
	return 1.0/(1.0+exp(-x))-0.5;
}
double Lnch(double x)
{
	return log(2.0*cosh(x/2.0));
}
double LogCosh(int i,double x)
{
	double p;
	p=(x-xi(i))/h; 
	return 2.0*((p+1.0)*Expp(p+1.0)+(p-1.0)*Expp(p-1.0)-2.0*p*Expp(p))-
		(Lnch(p+1.0)+Lnch(p-1.0)-2.0*Lnch(p));
}
double FiDel(int i,double x)
{
	switch (method_approx)
	{
	case 1: return Lagr(i,x); 
	case 2: return Trig(i,x);
	case 3: return Tcos(i,x);
	case 4: return Tsin(i,x);
	case 5: return NDel(i,x);
	case 6: return LDel(i,x);
	case 7: return NlocDel(i,x);
	case 8: return ErfSt(i,x);
	case 9: return ErfKr(i,x);
	case 10: return LogCosh(i,x);

	default: return printf("sorry 2, bad parameter method_approx", cout <<'\n');
	}
}
double SummaDel(double x)//.137
{
	int i,imin,imax; double s; 
	switch (method_approx)
	{
	case 1: imin=0; imax=n-1; break; 
	case 2: imin=-n; imax=n; break;
	case 3: imin=0;imax=n; break;
	case 4: imin=0;imax=n-1; break;
	case 5: imin=0; imax=n-1; break; 
	case 6: imin=0; imax=n-1; break; 
	case 7: imin=0; imax=n-1; break; 
	case 8: imin=0; imax=n-1; break; 
	case 9: imin=0; imax=n-1; break; 
	case 10: imin=0; imax=n-1; break; 
	default: 
		printf("sorry 3, bad parameter method_approx", cout <<'\n');
	}
	s=0.0;
	for (i=imin;i<=imax;i++)
		{
		s=s+(f(xi(i))-Ylin(xi(i)))*FiDel(i,x);
		};
	return s;
}

double fInt(double x)
{
	return atan(x*5.0)/5.0;
}
double G(double x,double y)
{
	double h1=h*al;double p=fabs(x-y);double q=fabs((x-y)/h1);double r=fabs((x-y)/h); 
	double h2=(b1-al);double q2=fabs((x-y)/h2);	double d=(x-y)/h; 

	switch (method_approx)
	{
	case 5: return p*p*p;
	case 6: return (1.0+q+(1.0/3.0)*q*q)*exp(-q);
	case 7: return (q<1.0)? (-step(3,q)/3.0+step(2,q)+1.0/3.0):q;
	case 8: return (r<0.5)? (r*r+0.25): r;
	case 9: return Stu(st,q);
	case 10: return p;
	case 11: return step(3,sqrt(p));
	case 12: return Stuloc(st,stloc,q);
	case 13: return sin(q)-q*cos(q);
	case 14: return exp(-q)*(sin(q)+cos(q));
	case 15: return p*p*p*p*p;
	case 16: return sinh(q)-q-q*q*q/6;
	case 17: return q*(exp(-x/h1)+exp(-y/h1))/2.0+sgn(x-y)*(exp(-x/h1)-exp(-y/h1));
	case 18: return q-(1.0+x/h1*y/h1)*sgn(x-y)*(atan(x/h1)-atan(y/h1));
	case 19: return (Erff((d+1.0)/sqrt(2.0))+Erff((d-1.0)/sqrt(2.0))-2.0*Erff(d/sqrt(2.0)))/sqrt(2.0);
	case 20: return (Erf((d+0.5)/sqrt(2.0))-Erf((d-0.5)/sqrt(2.0)))/2.0;
	case 21: return 2.0*((d+1.0)*Expp(d+1.0)+(d-1.0)*Expp(d-1.0)-2.0*d*Expp(d))-
			(Lnch(d+1.0)+Lnch(d-1.0)-2.0*Lnch(d));

	default: return printf("sorry, method", cout <<'\n');
	}
}

	double J0(double x)
{
	double y,p,q,f0,tet0;
	
	if (fabs(x)<3.0) {p=x/3.0;
		y=1.0-2.2499997*step(2,p)+1.2656208*step(4,p)-0.3163866*step(6,p)+
		0.0444479*step(8,p)-0.0039444*step(10,p)+0.0002100*step(12,p);} 
	else 
	{
		q=3.0/x;
		f0=0.79788456-0.00000077*q-0.00552740*q*q-0.00009512*q*q*q+
			0.00137273*step(4,q)-0.00072805*step(5,q)+0.00014476*step(6,q);
		tet0=x-0.78539816-0.04166397*q-0.00003954*q*q+0.00262573*q*q*q-
			0.00054125*step(4,q)-0.00029333*step(5,q)+0.00013558*step(6,q);
	y=1.0/sqrt(x)*f0*cos(tet0);
	}
	return y;
}
double reIU(double x)
{	
	double a2,b2,u,v;
	switch (primIU)
	{
	case 1: return step(2,cos(pi/2.0*x));
	case 2: return step(2,sin(pi/2.0*x));
	case 3: return (fabs(x)<0.75)? (1.0-fabs(x/0.75)): 0.0; 
	case 4: {a2=x-0.5; b2=x+0.5; u=1.0/(1.0+100.0*a2*a2);v=1.0/(1.0+100.0*b2*b2);return u+v;};
	case 5: 
		if (fabs(x)<0.85)
		{a2=sin(pi*x/0.85); b2=cos(6.5*pi*x/0.85); u=step(2,1.0-step(2,x/0.85))+0.5*step(4,a2)*b2;}
		else u=0.0;
		return u;
	case 6: 
		if (fabs(x)<0.85)
		{a2=cos(pi*x/1.7); b2=cos(4.5*pi*x/0.85); u=0.5*(step(2,1.0-step(2,x/0.85))+a2*a2*b2);}
		else u=0.0;
		return u;
	case 7: return 1.0-x; 
	case 8: return //J0(pi*sqrt(1.0000000001-x*x));  
				Bessel(0,pi*sqrt(1.0000000001-x*x));
	case 9: return 5.0*sgn(x)*x*x*(1-x*x); 
	case 10: return 1.0; 
	default: return printf("sorry, primer", cout <<'\n');
	}
}
double K(double x,double y)
{
	switch (primIU)
	{
	case 1: return step(4,cos(pi/2.0*(x-y)));
	case 2: return step(4,cos(pi/2.0*(x-y)));
	case 3: return sqrt(25.0/pi)*exp(-25.0*(x-y)*(x-y));
	case 4: return sqrt(25.0/pi)*exp(-25.0*(x-y)*(x-y));
	case 5: return sqrt(60.0/pi)*exp(-60.0*(x-y)*(x-y)/(1.0+x*x));
	case 6: return sqrt(60.0/pi)*exp(-60.0*(x-y)*(x-y)/(1.0+x*x));
	case 7: return 1.0/(1.0+100.0*(x-y)*(x-y));
	case 8: return cos(pi*pi*x*y);
	case 9: return 1.0/(1.0+500.0*(x-y)*(x-y));
	case 10: return cos(x-y);
	default: return printf("sorry, method", cout <<'\n');
	}
}
	double fIUoFIntegration(double x)
{
	int i,n1; double y,s1,s2,h1;

	n1=25;h1=(b1-a1)/(2.0*n1);s2=0.0; s1=K(x,b1-h1)*reIU(b1-h1);y=a1;
	for (i=1;i<n1;i++)
		{
		y=y+h1;s1=s1+K(x,y)*reIU(y);
		y=y+h1;s2=s2+K(x,y)*reIU(y);
		};
	return (K(x,a1)*reIU(a1)+K(x,b1)*reIU(b1)+4.0*s1+2.0*s2)*h1/3.0;
}

double fIU(double x)
{	
	switch (primIU)
	{
	case 1: return 
				0.5*step(2,cos(pi/2.0*x))+0.125;
	case 2: return 
				0.5*step(2,sin(pi/2.0*x))+0.125;
	case 3: return fIUoFIntegration(x);
	case 4: return fIUoFIntegration(x);
	case 5: return fIUoFIntegration(x);
	case 6: return fIUoFIntegration(x);
	case 7: return
				//(10.0*(1.0-x)*(atan(10.0*(x+1.0))-atan(10.0*(x-1.0))-0.5*log((1.0+100.0*(x-1.0)*(x-1.0))/
				//(1.0+100.0*(1.0+x)*(1.0+x)))/100.0;
				fIUoFIntegration(x);
	case 8: return 2.0*sin(pi*sqrt(1.0+pi*pi*x*x))/(pi*sqrt(1.0+pi*pi*x*x));
	case 9: return fIUoFIntegration(x);
	case 10: return 4.0/pi*cos(pi/2.0*x); 
	default: return printf("sorry, primer", cout <<'\n');
	}
}
void Gauss(double a[n][n],double b[n],double x[n])//.137
{
	int i,j,k;
	double det=1.0;
	for (k=0;k<n-1;k++)
	{
	///*
		int l=k; double t=fabs(a[k][k]);
		for (i=k+1;i<n;i++)
		if (fabs(a[i][k])>t){l=i;t=fabs(a[i][k]);};
		if (l!=k) 
		{
		for (j=k;j<n;j++)
		{t=a[k][j];a[k][j]=a[l][j];a[l][j]=t;};
		t=b[k]; b[k]=b[l];b[l]=t; 
		}
	//*/
		det*=a[k][k];
		for (i=k+1;i<n;i++)
		{
		double d=a[i][k]/a[k][k];
		for (j=k+1;j<n;j++) a[i][j]-=d*a[k][j];
		b[i]-=d*b[k];
		}
	};
	x[n-1]=b[n-1]/a[n-1][n-1];
	for (i=n-2;i>=0;i--)
	{
	double s=0;
	for (j=i+1;j<n;j++) s=s+a[i][j]*x[j];
		x[i]=(b[i]-s)/a[i][i];
	};
	cout <<"det="<<det<<"   ";
	printf("n=   %d   Hello Gauss\n",n);
	return;
}

double Fi(int i,double x)
	{
	return G(x,a1+i*h);
	}
double Fii(int i,double x)
	{
	return h*BasInt((x-(a1+i*h))/h);
	}


double FiY(int i,double y)
	{
	return //G(a1+i*h,y);
		K(a1+i*h,y);
	}
double FiX(int j,double x)
	{
	return //G(x,a1+j*h);
		K(x,a1+j*h);
	}

double Integr_YY(int j,int i)
{
	int k; double s,c,yc,yl,yr,fc,fl,fr,hy;
	hy=(b1-a1)/double(ny); c=sqrt(3.0/5.0); s=0.0; 
	for (k=0;k<nx;k++)
		{
		yc=a1+k*hy+hy/2.0; yl=yc-c*hy/2.0; yr=yc+c*hy/2.0;
		fc=FiY(j,yc)*FiY(i,yc);fl=FiY(j,yl)*FiY(i,yl); fr=FiY(j,yr)*FiY(i,yr);
		s=s+5.0*fl+8.0*fc+5.0*fr;
		};
	return s*hy/18.0;
}

double Integr_KY(int i,double x)
{
	int k; double s,c,yc,yl,yr,fc,fl,fr,hy;
	hy=(b1-a1)/double(ny); c=sqrt(3.0/5.0); s=0.0; 
	for (k=0;k<ny;k++)
		{
		yc=a1+k*hy+hy/2.0; yl=yc-c*hy/2.0; yr=yc+c*hy/2.0;
		fc=K(x,yc)*FiY(i,yc);fl=K(x,yl)*FiY(i,yl); fr=K(x,yr)*FiY(i,yr);
		s=s+5.0*fl+8.0*fc+5.0*fr;
		};
	return s*hy/18.0;
}


double Integr_XKY(int j,int i)
{
	int k; double s,c,xc,xl,xr,fc,fl,fr,hx;
	hx=(b1-a1)/double(nx); c=sqrt(3.0/5.0); s=0.0; 
	for (k=0;k<nx;k++)
		{
		xc=a1+k*hx+hx/2.0; xl=xc-c*hx/2.0; xr=xc+c*hx/2.0;
		fc=FiX(j,xc)*Integr_KY(i,xc);fl=FiX(j,xl)*Integr_KY(i,xl); fr=FiX(j,xr)*Integr_KY(i,xr);
		s=s+5.0*fl+8.0*fc+5.0*fr;
		};
	return s*hx/18.0;
}
double Integr_Kf(int j)
{
	int k; double s,c,xc,xl,xr,fc,fl,fr,hx;
	hx=(b1-a1)/double(nx); c=sqrt(3.0/5.0); s=0.0; 
	for (k=0;k<nx;k++)
		{
		xc=a1+k*hx+hx/2.0; xl=xc-c*hx/2.0; xr=xc+c*hx/2.0;
		fc=FiX(j,xc)*fIU(xc);fl=FiX(j,xl)*fIU(xl); fr=FiX(j,xr)*fIU(xr);
		s=s+5.0*fl+8.0*fc+5.0*fr;
		};
	return s*hx/18.0;
}

double Prod_KYKY(int j,int i)
{
	int k; double s,xc,fc;
	double hf=(b1-a1)/double(nf); s=0.0; 
	for (k=0;k<nf;k++)
		{
		xc=a1+k*hf+hf/2.0; 
		fc=Integr_KY(j,xc)*Integr_KY(i,xc);
		s=s+fc;
		};
	return s*hf;
}
double Prod_KYf(int j)
{
	int k; double s,xc,fc;
	double hf=(b1-a1)/double(nf); s=0.0; 
	for (k=0;k<nf;k++)
		{
		xc=a1+k*hf+hf/2.0; 
		fc=Integr_KY(j,xc)*fIU(xc);
		s=s+fc;
		};
	return s*hf;
}
void ProectionfIUonRK(double c[n])
{
	int i,j; 
	//double hp=(b1-a1)/double(np);
	for (j=0;j<n;j++)
	for (i=0;i<n;i++)
		{
			a[j][i]=Prod_KYKY(j,i);
				//Integr_KY(i,a1+j*hp);
				//Integr_YY(j,i);
				//(CL_1_2==1)? Integr_XKY(j,i): Prod_KYKY(j,i);
		if (i==j) a[j][i]+=epsIU;
		};
	for (j=0;j<n;j++)
		{
			b[j]=Prod_KYf(j);
				//fIU(a1+j*hp);
				//(CL_1_2==1)? Integr_Kf(j):Prod_KYf(j);
		};
		Gauss(a,b,c);
	printf("n=   %d   MatrixVectIU\n",n);
	return;
}
double Sum(double c[n],double x)
{
	int i; double s;
		s=0.0;
	for (i=0;i<n;i++)
		{
		s=s+Integr_KY(i,x)*c[i];
		};
	return s;
}
double Integr_Ks(int j)
{
	int k; double s,d,xc,xl,xr,fc,fl,fr,hx;
	hx=(b1-a1)/double(nx); d=sqrt(3.0/5.0); s=0.0; 
	for (k=0;k<nx;k++)
		{
		xc=a1+k*hx+hx/2.0; xl=xc-d*hx/2.0; xr=xc+d*hx/2.0;
		fc=FiX(j,xc)*Sum(c,xc);fl=FiX(j,xl)*Sum(c,xl); fr=FiX(j,xr)*Sum(c,xr);
		s=s+5.0*fl+8.0*fc+5.0*fr;
		};
	return s*hx/18.0;
}

void MatrixVectIU(double a[n][n],double b[n])//.137
{
	int i,j; 
	for (j=0;j<n;j++)
	for (i=0;i<n;i++)
		{
			a[j][i]=Integr_XKY(j,i);
				//Integr_YY(j,i);
				//(CL_1_2==1)? Integr_XKY(j,i): Prod_KYKY(j,i);
		if (i==j) a[j][i]+=epsIU;
		};
	for (j=0;j<n;j++)
		{
			b[j]=Integr_Ks(j);
				//Sum(c,a1+j*h);
				//fIU(a1+j*h);
				//(CL_1_2==1)? Integr_Kf(j):Prod_KYf(j);
		};
	printf("n=   %d   MatrixVectIU\n",n);
	return;
}

void MatrixVect0(double a[n][n],double b[n])//.137
{
	int i,j; 

	for (i=0;i<n;i++)
	for (j=0;j<n;j++)
		{
		double x2=a1+j*h;
		a[j][i]=Fi(i,x2);
		};

	for (j=0;j<n;j++)
		{b[j]=0.0;
		for (i=0;i<n;i++)
		b[j]=b[j]+a[j][i];
		};
	printf("n=   %d   MatrixVect0\n",n);
	return;
}
void MatrixOut(double a[n][n])
{
	int i,j; 

	for (j=0;j<n;j++)
	{
		for (i=0;i<n;i++)
		cout <<a[j][i]<<"   ";
		cout <<'\n';
		/*endl;*/
	};
	printf("n=   %d   MatrixOut\n",n);
	return;
}
void MatrixVectf(double a[n][n],double b[n])//.137
{
	int i,j; 

	for (i=0;i<n;i++)
	for (j=0;j<n;j++)
		{
		double x2=a1+j*h;
		a[j][i]=Fi(i,x2);
		};

	for (j=0;j<n;j++)
		{
		b[j]=f(a1+j*h);
		};
	printf("n=   %d   MatrixVectf\n",n);
	return;
}
void MatrixVectA(double a[n][n],double b[n])//.137
{
	int i,j; double x2;

	for (i=0;i<n;i++)
	for (j=0;j<n;j++)
		{
		if (setka==0) x2=a1+j*h;else x2=cos((2.0*j+1)*pi/2./n);
		a[j][i]=step(i,x2);
		};

	for (j=0;j<n;j++)
		{
		if (setka==0) x2=a1+j*h;else x2=cos((2.0*j+1)*pi/2./n);
		b[j]=f(x2);
		};
		
	printf("n=   %d   MatrixVectA\n",n);
	return;
}
void MatrixVectB(double alf[n],double bet[n],double gam[n],double b[n])//.137
{
	int i; 
	for (i=0;i<n;i++)         
		{
			alf[i]=(SpB==3)? 2.0/3.0: 0.75; b[i]=f(a1+i*h);
		};
	for (i=0;i<n-1;i++)
		{
		bet[i]=(SpB==3)? 1.0/6.0: 0.125; gam[i]=(SpB==3)? 1.0/6.0: 0.125; 
		};
	bet[n-1]=0.0;gam[n-1]=0.0;
	printf("n=   %d   MatrixVectB\n",n);
	return;
}

void MatrixOut3(double alf[n],double bet[n],double gam[n],double a[n][n])
{
	int i,j; 
	for (i=0;i<n;i++)
	for (j=0;j<n;j++)
		{
		a[j][i]=0.0;
		};
	
	for (i=0;i<n;i++)
		{
		if (i==0)
		{a[i][i]=alf[i];a[i][i+1]=gam[i];}
		else 
		if (i<n-1)
		{a[i][i-1]=bet[i-1];a[i][i]=alf[i];a[i][i+1]=gam[i];}
		else 
		{a[n-1][n-2]=bet[n-2];a[n-1][n-1]=alf[n-1];}
		};

	for (j=0;j<n;j++)
	{
		for (i=0;i<n;i++)
		cout <<a[j][i]<<"   ";
		cout <<'\n';
	};
	printf("n=   %d   MatrixOut3\n",n);
	return;
}

void MatrixVectS(double alf[n],double bet[n],double gam[n],double b[n])//.137
{
	int i; 
		for (i=1;i<=(n-2);i++)
		{alf[i-1]=2.0/3.0;b[i-1]=(f(a1+(i-1)*h)-2.0*f(a1+i*h)+f(a1+(i+1)*h))/h/h;};
	for (i=1;i<=(n-3);i++)
		{bet[i-1]=1.0/6.0;gam[i-1]=1.0/6.0;};
		bet[n-3]=0.0;gam[n-3]=0.0;
	printf("n=   %d   MatrixVectS\n",n);
	return;
}

void GaussIU(double a[n][n],double b[n],double x[n])//.137
{
	int i,j,k; 
	for (k=0;k<n-1;k++)
	{
	///*
		int l=k; double t=fabs(a[k][k]);
		for (i=k+1;i<n;i++)
		if (fabs(a[i][k])>t){l=i;t=fabs(a[i][k]);};
		if (l!=k) 
		{
		for (j=k;j<n;j++)
		{t=a[k][j];a[k][j]=a[l][j];a[l][j]=t;};
		t=b[k]; b[k]=b[l];b[l]=t; 
		}
	//*/
		for (i=k+1;i<n;i++)
		{
		double d=1.0/a[k][k];float df=float(d);
		for (j=k+1;j<n;j++) a[i][j]-=df*a[i][k]*a[k][j];
		b[i]-=df*a[i][k]*b[k];
		}
	};
	double d=1.0/a[n-1][n-1]; float df=float(d); x[n-1]=b[n-1]*df;
	for (i=n-2;i>=0;i--)
	{
	double s=0;
	for (j=i+1;j<n;j++) s=s+a[i][j]*x[j];
	double d=1.0/a[i][i]; float df=float(d); 
		x[i]=(b[i]-s)*df;
	};
	printf("n=   %d   Hello Gauss\n",n);
	return;
}
void VectOut(double x[n])//.137
{
	int i; 


	for (i=0;i<n;i++)
	{
		cout <<x[i]<<"   ";
		cout <<'\n';
	};
	printf("n=   %d   Hello VectOut\n",n);
	return;
}
void GaussJ(double a[n][n],double b[n],double x[n])//.137
{
	int i,j,k; 
	for (k=0;k<n;k++)
	{
	///*
		int l=k; double t=fabs(a[k][k]);
		for (i=k+1;i<n;i++)
		if (fabs(a[i][k])>t){l=i;t=fabs(a[i][k]);};
		if (l!=k) 
		{
		for (j=k;j<n;j++)
		{double t=a[k][j];a[k][j]=a[l][j];a[l][j]=t;};
		t=b[k]; b[k]=b[l];b[l]=t; 
		}
	//*/
	for (j=k+1;j<n;j++) a[k][j]/=a[k][k];
        b[k]/=a[k][k];
		for (i=0;i<n;i++)
		if (i!=k) 
		{
		for (j=k+1;j<n;j++) a[i][j]-=a[i][k]*a[k][j];
			b[i]-=a[i][k]*b[k];
		};
	};
	for (i=0;i<n;i++) x[i]=b[i];
	printf("n=   %d   Hello Gauss-Jordan\n",n);
	return;
}
void Zeidel(double a[n][n],double b[n],double x[n])//.137
{
	int i,j,k; double s,t,d,r;

	for (i=0;i<n;i++) x[i]=0.0;
	for (k=0;k<kmax;k++)
	{
		d=-1.0;
		for (i=0;i<n;i++)
		{
			s=0.0;
			for (j=0;j<i;j++) s=s+a[i][j]*x[j];
			for (j=i+1;j<n;j++)   s=s+a[i][j]*x[j];
			t=(b[i]-s)/a[i][i]; r=fabs(t-x[i]);
			if (r>d) d=r;
			x[i]=t;
		};
		if (d<eps) goto M2;
	}
		printf("k=   %d tochnost ne dostignuta\n",k);
		goto M1;
		M2: 
		printf("k=   %d   Hello Zeidel\n",k);
M1: return;
}
void GaussB(double alf[n],double bet[n],double gam[n],double b[n],double x[n])//.137
{
	int i; 
	for (i=1;i<n;i++)
	{
	alf[i]=alf[i]-bet[i-1]*gam[i-1]/alf[i-1];
	b[i]=b[i]-bet[i-1]*b[i-1]/alf[i-1];
	}
	x[n-1]=b[n-1]/alf[n-1];
	for (i=n-2;i>=0;i--) x[i]=(b[i]-gam[i]*x[i+1])/alf[i];
	printf("n=   %d   Hello GaussB\n",n);
	return;
}
void GaussS3(double alf[n],double bet[n],double gam[n],double b[n],double x[n])//.137
{
	int i; 
	for (i=1;i<=(n-3);i++)
	{
	alf[i]=alf[i]-bet[i-1]*gam[i-1]/alf[i-1];
	b[i]=b[i]-bet[i-1]*b[i-1]/alf[i-1];
	}
	x[n-3]=b[n-3]/alf[n-3];
	for (i=(n-4);i>=0;i--) x[i]=(b[i]-gam[i]*x[i+1])/alf[i];
	printf("n=   %d   Hello GaussS3\n",n);
	return;
}
void GaussO2(double x[n])//.137
{
	int i; double x1,s;
		x[0]=0.0;
		for (i=0;i<n;i++)
		{
		s=0.0;x1=a1+i*h;
		for (j=0;j<i;j++) s=s+x[j];
		x[i]=(f(x1)-s)*2.0;
		}
	printf("n=   %d   Hello GaussO2\n",n);
	return;
}

double Summa(double x[n],double y)//.137
{
	int i; double s;
	s=0.0;
	for (i=0;i<n;i++)
		{
		s=s+FiY(i,y)*x[i];
			//Fi(i,y)*x[i];
		};
	return s;
}
double SummaA(double x[n],double y)//.137
{
	int i; double p;
	p=x[n-1];
	for (i=n-2;i>=0;i--) p=x[i]+y*p;
	return p;
}
double SummaS3(double y,double x[n],double bs[n],double cs[n],double ds[n])//.137
{
	int i; double r,s;
	for (i=0;i<=(n-2);i++)
		{
	if (i==0) {bs[i]=(f(a1+h)-f(a1))/h-h/6.0*x[0];cs[i]=0.0;ds[i]=x[0]/6.0/h;}
	else
	if (i==(n-2)) {bs[i]=(f(b1)-f(a1-h))/h-h/3.0*x[n-3];cs[i]=x[n-3]/2.0;ds[i]=-x[n-3]/6.0/h;}
	else 
		{bs[i]=(f(a1+(i+1)*h)-f(a1+i*h))/h-h/6.0*(x[i]+2.0*x[i-1]);cs[i]=x[i-1]/2.0; ds[i]=(x[i]-x[i-1])/6.0/h;};
	};
	i=int((y-a1)/h);
	if (i==(n-1)) return f(b1);
	else 
		{r=y-(a1+i*h);
		s=f(a1+i*h)+bs[i]*r+cs[i]*r*r+ds[i]*r*r*r;
		return s;}
}

double SummaB(double x[n],double y)
{
	int i,j; double s,z;
	i=int((y-a1)/h); 
	if (i==0) 
	{s=0.0;for (j=0;j<=2;j++) {z=(SpB==3)? Sp_B3((y-(a1+j*h))/h):Sp_B2((y-(a1+j*h))/h); s=s+z*x[j];};
	return s;
	}
	else
	if (i==(n-1))
	{s=0.0;for (j=(n-3);j<=(n-1);j++) 
	{z=(SpB==3)? Sp_B3((y-(a1+j*h))/h):Sp_B2((y-(a1+j*h))/h); s=s+z*x[j];};
	return s;
	}
	else 
	if (i==n)return f(b1);
	else
	{s=0.0;for (j=(i-1);j<=(i+2);j++)
	{z=(SpB==3)? Sp_B3((y-(a1+j*h))/h):Sp_B2((y-(a1+j*h))/h); s=s+z*x[j];};
	return s;};	

}
double SummaO2(double x[n],double y)
{
	int i,j; double s,x1;
	i=int((y-a1)/h);
	s=0.0;
	for (j=1;j<i+2;j++)
		{
		x1=(y-(a1+j*h))/h;
		s=s+Sp_O2(x1)*x[j];
		};
	return (f(a1)+s);
}
double alfa(int j)
{
	int i; double y,s,z;

	s=0.0;
	for (i=-n;i<=n;i++)
		{
		y=2.0/(2.0*n+1.0)*i;
		z=f(y)-(f(a1)+(f(b1)-f(a1))*(y-a1)/(b1-a1));
		s=s+z*cos(pi*j*y);
		};
	return s*2.0/(2.0*n+1.0);
}
double beta(int j)
{
	int i; double y,s,z;
	s=0.0;
	for (i=-n;i<=n;i++)
		{
		y=2.0/(2.0*n+1.0)*i;
		z=f(y)-(f(a1)+(f(b1)-f(a1))*(y-a1)/(b1-a1));
		s=s+z*sin(pi*j*y);
		};
	return s*2.0/(2.0*n+1.0);
}
double SummaT(double x)
{
	int j; double s,z;

	s=0.0;z=f(a1)+(f(b1)-f(a1))*(x-a1)/(b1-a1);
	for (j=1;j<=n;j++) s=s+(alfa(j)*cos(pi*j*x)+beta(j)*sin(pi*j*x)); 
	s=s+alfa(0)/2.0+z; 
	return s;
}
double SummaI(double y)//.137
{
	int i; double s;
	s=0.0;
	for (i=0;i<n;i++)
		{
		s=s+(Fii(i,y)-Fii(i,0))*f(a1+i*h);
		};
	return s;
}
double SummaS3I(double y,double x[n],double bs[n],double cs[n],double ds[n])//.137
{
	int i; double r,s;
	for (i=0;i<=(n-2);i++)
		{
	if (i==0) {bs[i]=(f(a1+h)-f(a1))/h-h/6.0*x[0];cs[i]=0.0;ds[i]=x[0]/6.0/h;}
	else
	if (i==(n-2)) {bs[i]=(f(b1)-f(a1-h))/h-h/3.0*x[n-3];cs[i]=x[n-3]/2.0;ds[i]=-x[n-3]/6.0/h;}
	else 
		{bs[i]=(f(a1+(i+1)*h)-f(a1+i*h))/h-h/6.0*(x[i]+2.0*x[i-1]);cs[i]=x[i-1]/2.0; ds[i]=(x[i]-x[i-1])/6.0/h;};
	};
	es[0]=0.0;
	for (i=0;i<=(n-2);i++) es[i+1]=es[i]+f(a1+i*h)*h+bs[i]*h*h/2.0+cs[i]*h*h*h/3.0+ds[i]*h*h*h*h/4.0;
		i=int((y-a1)/h);
		{r=y-(a1+i*h);
		s=es[i]+f(a1+i*h)*r+bs[i]*r*r/2.0+cs[i]*r*r*r/3.0+ds[i]*r*r*r*r/4.0;
		return s;}
}
double p(double x)
	{
		switch (primerg)
	{
	case 1: return 1.0;//  15)
	case 2: return 1.0;// 5),x>=0
	case 3: return (1.0+x*x);// 18)
	case 4: return x*x;// 17)
	case 5: return 1.0;// 16)
	case 6: return x;// 19),x>0.0
	case 7: return x;// 14),x>0.0
	case 8:return (1.0+x*x);// 11)
	case 9: return x*cos(x)-sin(x);// 10),x>0,x<=pi
	case 10: return 1.0;// 13)
	case 11: return 1.0;// 8)
	case 12: return x;// 9),x>0
	case 13: return 1.0;// 20)
	case 14: return 1.0;// 6),x>=0
	case 15: return 1.0;// 12)
	case 16: return 1.0;// 7)
	case 17:return 0.02*step(3,1.0+25.0*x*x);
	case 18: return (1.0-x*x)*x;     //  
	case 19: return (x*x-0.25)*x*x;  
	case 20: return x*x;     // 

	default: return printf("sorry, primer", cout <<'\n');
	}	
}
double q(double x)
	{
	double ad=1.0;int bi=0;//   12
	double a6=-1.0;//   14
	switch (primerg)
	{
	case 1: return 4.0*x;
	case 2: return x;
	case 3: return 2.0*x;
	case 4: return -2.0*x;
	case 5: return x;
	case 6: return -(x+1.0);
	case 7: return -(x+1.0);
	case 8: return 4.0*x;
	case 9: return x*sin(x);
	case 10: return sin(x)/cos(x);
	case 11: return sin(x)/cos(x);
	case 12: return -2.0*(ad*x+bi);
	case 13: return -4.0*x;
	case 14: return 2.0*a6*x;
	case 15: return -4.0*x;
	case 16: return 0.0;
	case 17:return 0.02*step(2,1.0+25.0*x*x);
	case 18: return (1.0-x*x);     
	case 19: return 0.0;    
	case 20: return x;     // 

	default: return printf("sorry, primer", cout <<'\n');
	}	

}
double r(double x)
	{
	double ad=1.0;int bi=0;double a6=-1.0;double k4=0.25; //   4)
	double p1=10.0;//   16
	switch (primerg)
	{
	case 1: return (2.0+x*x*4.0);
	case 2: return (0.5+x*x/4.0);
	case 3: return 1.0/(1.0+x*x);
	case 4: return (2.0+k4*k4*x*x);
	case 5: return 0.25*x*x-1.0;
	case 6: return -2.0*(x-1.0);
	case 7: return 1.0;
	case 8:return 2.0;
	case 9: return -sin(x);
	case 10: return -cos(x)*cos(x);
	case 11: return cos(x)*cos(x);
	case 12: return ad*ad*x+2.0*ad*bi;
	case 13: return	(4.0*x*x-2.0);
	case 14: return	step(2,a6*x);
	case 15: return	(1.0+4.0*x*x);
	case 16: return	(p1*p1)/step(2,p1*p1+x*x);
	case 17:return 1.0+25.0*x*x;
	case 18: return x;     
	case 19: return 1.0/16.0;    
	case 20: return x*x-pr*pr;     // 

	default: return printf("sorry, primer", cout <<'\n');
	}	

}
double fg(double x)
	{
	switch (primerg)
	{
	case 1: return 0.0;
	case 2: return 0.0;
	case 3: return 0.0;
	case 4: return 0.0;
	case 5: return 0.0;
	case 6: return 0.0;
	case 7: return 0.0;
	case 8:return 2.0*(cos(x)-x);
	case 9: return 0.0;
	case 10: return 0.0;
	case 11: return 0.0;
	case 12: return 0.0;
	case 13: return 0.0;
	case 14: return 0.0;
	case 15: return exp(x*x);
	case 16: return 0.0;
	case 17:return 75.0*x*x-x;
	case 18: return 0.0;     // 18)
	case 19: return 0.0;
	case 20: return 0.0;     // 

	default: return printf("sorry, primer", cout <<'\n');
	}	

}
double re(double x)
	{
	double c1=1.0;double c2=1.0;
	double ad=1.0;int bi=0;double a6=-1.0;double k4=0.25; 
	double p1=10.0;
	double u;
	switch (primerg)
	{
	case 1: return exp(-x*x)*(c1+c2*x);
	case 2: return exp(-x*x/4)*(c1+c2*x);
	case 3: return 1.0/sqrt(1.0+x*x)*(c1+c2*x);
	case 4: return x*(c1*cos(k4*x)+c2*sin(k4*x));
	case 5: return exp(-x*x/4.0)*(c1*exp(x*sqrt(1.5))+c2*exp(-x*sqrt(1.5)));
	case 6: return c1*(3.0*x+1.0)*exp(-x)+c2*exp(2.0*x);
	case 7: return c1*(x+1)+c2*exp(x);
	case 8:return 1.0/(1.0+x*x)*(c1+c2*x-x*x*x/3.0-2.0*cos(x));
	case 9: return c1*x+c2*sin(x);
	case 10: return c1*exp(sin(x))+c2*exp(-sin(x));
	case 11: return c1*cos(sin(x))+c2*sin(sin(x));
	case 12: return	exp(ad*x)*(c1+c2*step(2*bi+1,x));
	case 13: return	exp(x*x)*(c1+c2*x);
	case 14: return	(a6>0.0)? exp(-a6*x*x/2.0)*(c1*cosh(x*sqrt(a6))+c2*sinh(x*sqrt(a6))):
				 exp(-a6*x*x/2.0)*(c1*cos(x*sqrt(-a6))+c2*sin(x*sqrt(-a6)));
	case 15: return	exp(x*x)*(1.0+c1*cos(x)+c2*sin(x));
	case 16: u=sqrt(p1*p1+x*x)/p1*atan(x/p1);
			 return	sqrt(p1*p1+x*x)*(c1*cos(u)+c2*sin(u));
			 break;
	case 17:return 1.0/(1.0+25.0*x*x);
	case 18: return E(x);    
	case 19: return c1*sqrt(fabs(x))*sqrt(fabs(x-0.5))+c2*sqrt(fabs(x))*sqrt(fabs(x+0.5));    
	case 20: return Bessel(pr,x);     // 

	default: return printf("sorry, primer", cout <<'\n');
	}	
}
double rep(double x)
	{
	
	double u,v;
	double c1=1.0;double c2=1.0;double ad=1.0;int bi=0;double a6=-1.0;double k4=0.25; 
	double p1=10.0;
	switch (primerg)
	{
	case 1: return exp(-x*x)*(-x*2.0)*(1.0+x)+exp(-x*x); 
	case 2: return exp(-x*x/4)*(-x/2.0)*(1.0+x)+exp(-x*x/4.0);
	case 3: return (-x)*1.0/step(3,sqrt(1.0+x*x))*(1.0+x)+1.0/sqrt(1.0+x*x);
	case 4: return x*(-k4*sin(k4*x)+k4*cos(k4*x));
	case 5: return exp(-x*x/4)*(-x/2.0)*(exp(x*sqrt(1.5))+exp(-x*sqrt(1.5)))+
				exp(-x*x/4)*(sqrt(1.5)*exp(x*sqrt(1.5))-sqrt(1.5)*exp(-x*sqrt(1.5)));
	case 6: return c1*(3.0*exp(-x)-(3.0*x+1.0)*exp(-x))+c2*2.0*exp(2.0*x);
	case 7: return c1+c2*exp(x);
	case 8:return -(2.0*x)/step(2,sqrt(1.0+x*x))*(c1+c2*x-x*x*x/3.0-2.0*cos(x))+
			   1.0/(1.0+x*x)*(c2-x*x+2.0*sin(x));
	case 9: return c1+c2*cos(x);
	case 10: return c1*exp(sin(x))*cos(x)-c2*exp(-sin(x))*cos(x);
	case 11: return -c1*sin(sin(x))*cos(x)+c2*cos(sin(x))*cos(x);
	case 12: return	ad*exp(ad*x)*(c1+c2*step(2*bi+1,x))+exp(ad*x)*(2*bi+1)*c2*step(2*bi,x);
	case 13: return	exp(x*x)*(2.0*x)*(c1+c2*x)+exp(x*x)*c2;
	case 14: return	(a6>0.0)? exp(-a6*x*x/2.0)*(-a6*x)*(c1*cosh(x*sqrt(a6))+c2*sinh(x*sqrt(a6)))+
				 exp(-a6*x*x/2.0)*(c1*sinh(x*sqrt(a6))*sqrt(a6)+c2*cosh(x*sqrt(a6))*sqrt(a6)):
				 exp(-a6*x*x/2.0)*(-a6*x)*(c1*cos(x*sqrt(-a6))+c2*sin(x*sqrt(-a6)))+
				 exp(-a6*x*x/2.0)*(-c1*sin(x*sqrt(-a6))*sqrt(-a6)+c2*cos(x*sqrt(-a6))*sqrt(-a6));
	case 15: return	exp(x*x)*(2.0*x)*(1.0+c1*cos(x)+c2*sin(x))+exp(x*x)*(-c1*sin(x)+c2*cos(x));
	case 16: u=sqrt(p1*p1+x*x)/p1*atan(x/p1);v=1.0/sqrt(p1*p1+x*x)*((x/p1)*atan(x/p1)+1.0);
	return	x/sqrt(p1*p1+x*x)*(c1*cos(u)+c2*sin(u))+sqrt(p1*p1+x*x)*(-c1*sin(u)+c2*cos(u)*v);
	case 17:return -50.0*x/step(2,1.0+25.0*x*x);
	case 18: return E(x);     
	case 19: return c1*sqrt(fabs(x))*sqrt(fabs(x-0.5))+c2*sqrt(fabs(x))*sqrt(fabs(x-0.5));    
	case 20: return Bessel(pr,x);     // 

	default: return printf("sorry, primer", cout <<'\n');
	}	
}
double gaa(double y)
	{
	double ala=1.0;double bea=0.0;
	return ala*re(y)+bea*rep(y);
	}
double gab(double y)
	{
	double alb=1.0;double beb=0.0;
	return alb*re(y)+beb*rep(y);
	}
	double YGG(double y)
{
	double c,d;
		c=(re(a1)*b1-re(b1)*a1)/(b1-a1);
		d=(re(b1)-re(a1))/(b1-a1);
	return c+d*y;
}
double GG(double x,double y)
{
	double h1,p,q,qf,r,rf;
	h1=h*al; 
	p=(x-y); q=(x-y)/h1; qf=fabs(q); r=(x-y)/h; rf=fabs(r); 
	switch (method_approx)
	{
	case 5: return sgn(p)*p*p*p;
	case 6: return (1.0+qf+0.5*qf*qf)*exp(-qf);
	case 7: return (qf<1.0)? 0.5*(-step(3,qf)/3.0+step(2,qf)+1.0/3.0): 0.5*qf;
	case 8: return (rf<0.5)? 0.5*(rf*rf+0.25): 0.5*rf;
	case 9: return 1.0/step(st,1.0+q*q/(2*st-1.0));
	case 10: return sgn(p)*p*p*p*p*p;
	case 11: return sgn(p)*step(7,p);

	default: return printf("sorry, method", cout <<'\n');
	}
}
double GGp(double x,double y)
{
	double h1,p,q,qf,r,rf;
	h1=h*al; 
	p=(x-y); q=(x-y)/h1; qf=fabs(q); r=(x-y)/h; rf=fabs(r); 
	switch (method_approx)
	{
	case 5: return 3.0*sgn(p)*p*p;
	case 6: return -0.5*q*q*sgn(q)*exp(-qf)/h1;
	case 7: return (qf<1.0)? 0.5*(-sgn(q)*q*q+2.0*q)/h1:0.5*sgn(q)/h1;
	case 8: return (rf<0.5)? r: 0.5*sgn(r)/h;
	case 9: return -2.0*st*q/(2*st-1.0)/step(st+1,1.0+q*q/(2.0*st-1.0))/h1;
	case 10: return 5.0*sgn(p)*p*p*p*p;
	case 11: return 7.0*sgn(p)*step(6,p);
	default: return printf("sorry, method", cout <<'\n');
	}
}
double GGpp(double x,double y)
{
	double h1,p,q,qf,r,rf;
	h1=h*al; 
	p=(x-y); q=(x-y)/h1; qf=fabs(q); r=(x-y)/h; rf=fabs(r); 

	switch (method_approx)
	{
	case 5: return 6.0*sgn(p)*p;
	case 6: return ((0.5*q*q)-qf)*exp(-qf)/h1/h1;
	case 7: return (qf<1.0)? (-sgn(q)*q+1.0)/h1/h1:0.0;
	case 8: return (rf<0.5)? 1.0/h/h: 0.0;
	case 9: return -2.0*st/step(2,(2.0*st-1))/step(st+2,1.0+q*q/(2*st-1.0))*
					(2.0*st*(1-q*q)-(1+q*q))/h1/h1;
	case 10: return 20.0*sgn(p)*p*p*p;
	case 11: return 42.0*sgn(p)*step(5,p);
	default: return printf("sorry, method", cout <<'\n');
	}
}
double FiGG(int i,double x)
	{
	return GG(x,xi(i));
	}
double SummaGG(double x[n],double y)//.137
{
	int i; double s;
	s=0.0;
	for (i=0;i<n;i++)
		{
		s=s+FiGG(i,y)*x[i];
		};
	return s;
}
double SummaAG(double x[n],double y)//.137
{
	int i; double s;
	s=0.0;
	for (i=0;i<n;i++)
		{
		s=s+(y-a1)*(y-b1)*step(i,y)*x[i];
		};
	return s;
}

void MatrixVectGG(double a[n][n],double b[n])//.137
{
	double ala=1.0;double bea=0.0;double alb=1.0;double beb=0.0;
	int i,k; 
	for (i=0;i<n;i++)
	for (k=1;k<(n-1);k++)
		{
		a[k][i]=p(xi(k))*GGpp(xi(k),xi(i))+q(xi(k))*GGp(xi(k),xi(i))+r(xi(k))*GG(xi(k),xi(i));
		};
	for (i=0;i<n;i++)
		{
		a[0][i]=ala*GG(a1,xi(i))+bea*GGp(a1,xi(i));
		};
	for (i=0;i<n;i++)
		{
		a[n-1][i]=alb*GG(b1,xi(i))+beb*GGp(a1,xi(i));
		};
	for (k=1;k<(n-1);k++)
		{
		b[k]=fg(xi(k));
		};
		b[0]=gaa(a1);b[n-1]=gab(b1);
	printf("n=   %d   MatrixVectGG\n",n);
	return;
}
void MatrixVectAG(double a[n][n],double b[n])//.137
{
	int i,k; 
	double d=(re(b1)-re(a1))/(b1-a1);
	for (i=0;i<n;i++)
	for (k=0;k<n;k++)
		{
		a[k][i]=p(xi(k))*
			(
			(xi(k)-a1)*(xi(k)-b1)*i*(i-1)*step(i-2,xi(k))+2.0*(2.0*xi(k)-a1-b1)*i*step(i-1,xi(k))+2.0*step(i,xi(k))
			)
			+
			q(xi(k))*
			(
			(2.0*xi(k)-a1-b1)*step(i,xi(k))+(xi(k)-a1)*(xi(k)-b1)*i*step(i-1,xi(k))
			)
			+
			r(xi(k))*
			(
			(xi(k)-a1)*(xi(k)-b1)*step(i,xi(k))
			);

		};

	for (k=0;k<n;k++)
		{
		b[k]=fg(xi(k))-(d*q(xi(k))+YGG(xi(k))*r(xi(k)));
		};
	printf("n=   %d   MatrixVectAG\n",n);
	return;
}


void MatrixVectSet(double alf[n],double bet[n],double gam[n],double b[n])//.137
{
	int i; 
	double ala=1.0;double bea=0.0;double alb=1.0;double beb=0.0;

	alf[0]=ala*h-bea;gam[0]=bea; b[0]=h*gaa(a1); 
	for (i=1;i<=(n-2);i++)         
		{
			alf[i]=2.0*p(xi(i))-r(xi(i))*h*h; gam[i]=-p(xi(i))-q(xi(i))*h/2.0; b[i]=-h*h*fg(xi(i));
		};
	alf[n-1]=alb*h+beb; gam[n-1]=0.0;b[n-1]=h*gab(b1); 
	for (i=1;i<=(n-2);i++)
		{
		bet[i-1]=-p(xi(i))+q(xi(i))*h/2.0; 
		};
		bet[n-2]=-beb;bet[n-1]=0.0;
	printf("n=   %d   MatrixVectSet\n",n);
	return;
}
void Tabulation(int xp[ng],int yp[ng],int zp[ng])//.137
{
	int k; double y,NormC,NormL2,s,h,yd,yr,ymas,zmax,ymax,zmin,ymin,xg,yg,zg;		
	y=a1;NormC=-1.0;s=0;ymas=-1.0; double z=double(ng-1); h=(b1-a1)/z;
	for (k=0;k<ng;k++)
	{
		xg=y;
		//yg=re(y);
		//yg=f(y);
		yg=reIU(y);
		//yg=fInt(y);
		//zg=SummaI(y);
		//zg=SummaS3I(y,x,bs,cs,ds)-SummaS3I(0.0,x,bs,cs,ds);
		//goto Tab;
		if (method_approx==0) zg=SummaO2(x,y);
		else 
		if (method_approx==1) zg=SummaS3(y,x,bs,cs,ds);
		else 
		if (method_approx==2) zg=x[k];//SummaB(x,y);
		else 
		if (method_approx==3) zg=SummaAG(x,y)+YGG(y);
		else 
		if (method_approx==4) zg=SummaT(y);
		else 
			//zg=SummaGG(x,y);
			zg=Summa(x,y);
//Tab:    
		//zg=SummaDel(y)+Ylin(y);
		//if ((k>5)&&(k<(ng-5)))
		{yr=fabs(yg-zg);if (yr>NormC) NormC=yr;s=s+yr*yr;}
		
		if (fabs(yg)>fabs(zg)) yd=fabs(yg); else yd=fabs(zg); 
		if (yd>ymas) ymas=yd; 
		ymax=ymas+0.1*ymas;ymin=-ymax;
		zmax=ymax;zmin=ymin;
		xp[k]=int(640/(b1-a1)*(xg-a1));
		yp[k]=480-int(480/(ymax-ymin)*(yg-ymin));
		zp[k]=480-int(480/(zmax-zmin)*(zg-zmin));
		y=y+h;
	}
		NormL2=sqrt(s/z); 
		cout <<"NormC="<<NormC<<"   "<<"NormL2="<<NormL2<<"   "<<"a1="<<a1<<"   "<<"ymin="<<ymin<<"   ";
		cout <<'\n';
}
/*
void GraphicsC(int xp[ng],int yp[ng],int zp[ng])
{
	int Driver,Mode; 
	Driver=DETECT;
	initgraph(&Driver,&Mode," ");
	if (graphresult()!=grOk {cprintf("FAILURE")},exit(1));
	setbkcolor(1);

	for (int k=0;k<ng;k++)
	{
	putpixel(xp(k),yp(k),12);
	putpixel(xp(k),zp(k),13);
	}
	while (! kbhit());
	closegraph();
	return;
}
*/
int main()
{
//Tabulation(xp,yp,zp);
//goto M;
if (method_approx==0)
	{
	printf("\n");
	printf("\n");
GaussO2(x);
	printf("\n");
	printf("\n");
Tabulation(xp,yp,zp);
	goto M;
	}

if (method_approx==1)
	{
MatrixVectS(alf,bet,gam,b);
	printf("\n");
	printf("\n");
GaussS3(alf,bet,gam,b,x);
	printf("\n");
	printf("\n");
Tabulation(xp,yp,zp);
	goto M;
	}
if (method_approx==2)
	{
//MatrixVectB(alf,bet,gam,b);
MatrixVectSet(alf,bet,gam,b);
	printf("\n");
	printf("\n");
GaussB(alf,bet,gam,b,x);
	printf("\n");
	printf("\n");
Tabulation(xp,yp,zp);
	goto M;
	}
if (method_approx==3)
	{
MatrixVectAG(a,b);
	printf("\n");
	printf("\n");
//MatrixOut(a);
Gauss(a,b,x);
	printf("\n");
	printf("\n");
Tabulation(xp,yp,zp);
	goto M;
	}
if (method_approx==4)
	{
	printf("\n");
	printf("\n");
Tabulation(xp,yp,zp);
	goto M;
	}
if (method_RSLAE==1)
	{
//MatrixVectGG(a,b);
//MatrixVectf(a,b);
ProectionfIUonRK(c);
MatrixVectIU(a,b);
	printf("\n");
	printf("\n");
//Gauss(a,b,x);
	(kluchIU_1_2==1)? GaussIU(a,b,x):Gauss(a,b,x);
	printf("\n");
	printf("\n");
	}
	else 
if (method_RSLAE==2)
	{
//MatrixVectGG(a,b);
//MatrixVectf(a,b);
MatrixVectIU(a,b);
	printf("\n");
	printf("\n");
GaussJ(a,b,x);
	printf("\n");
	printf("\n");
	}
	else 
	{
MatrixVectf(a,b);
	printf("\n");
	printf("\n");
Zeidel(a,b,x);
	printf("\n");
	printf("\n");
	};
Tabulation(xp,yp,zp);

M:
 printf("\n");
 printf("\n");
 getchar();
return 0;
}
